// macros pFbook

///////////////////////////////////////////////////////////////
// 0 :  RAPPELS DE GEOMETRIE
// 01 : GEODESIQUES
// 1 :  CONSTRUCTION, DEFINITION
// 11 : FORMES MULTILINEAIRES RECURSIVES
//*		pF_111() 			// 4 le_point s  			( box + pers )
//*		pF_112( 0 ) 		// pL2					( box + pers, de 0  4 )
//		pF_113( 4 ) 		// pS22					( box + pers, de 0  6 )
//*		pF_114( 6 ) 		// pV222				( no box + pers, de 0  6 )
//*		pF_115() 			// pH2222				( box + pers )
// 12 : DIAGONALISATION
//*		pF_121( 0 ) 		// pS22 et pL3			( box + pers, de 0  4 )
//*		pF_122( 4 ) 		// pS23 et pL4			( box + pers, de 0  4 )
//*		pF_123() 			// pV222, pS23 et pL4	( no box + pers )
//		pF_124( 4 ) 		// pS33 et pL5			( box + pers, de 0  4 )
// 13 : GENERALISATION, LES pFORMES
//*		pF_130() 			// pV333, pS35 et pL7	( no box + pers )
// 2 : OPERATIONS, PROPRIETES
// 21 : OPERATIONS FONDAMENTALES
// 211 : SUBDIVISION
// 212 : ELEVATION DU DEGRE
//		pF_212()			// ondulations sur un arc de cercle
// 213 : REPARAMETRISATION
//*		pF_2131() 			// pL4 reparamtrise	( box + pers )
//*		pF_2132() 			// pS35 reparamtrise	( box + pers )
//*		pF_214( ) 			// pFgetSubForm, pFgetPoint, pFgetPijk 	( box + pers )
// 22 : IMMERSIONS
// 221 : INTERPOLATION
//*		pF_2211() 			// pL5 interpolante				( box + pers )
//		pF_2212() 			// pS35 interpolante			( no box + pers )
// 222 : DIAGONALISATION
// 		pF_222()			//  construire 
// 223 : pFORMES IMMERGEES
//*		pF_2235() 			// pL3 immerge dans une PS33	( box + pers )
//*		pF_2236() 			// pL4 immerge dans une PS33	( box + pers )
//		pF_2237()			// cf tore immerg dans un cube V223
// 23 : INTERFACE
// 231 : TRANSFORMATIONS
//*		pF_2311()			// pFrotate sur une pL4			( no box + pers )
//*		pF_2312()			// pFtranslate sur une pL4		( no box + pers )
//		pF_2313()			// pFscale sur une pL4			( no box + pers )
// 232 : REPRESENTATION
// 3 : COMPOSITIONS
// 31 : FORMES RATIONNELLES
// 311 : CONIQUES
//*		pF_3111()			// les 4 coniques comme projections de pL3 	( no box + pers )
//*		pF_31121()			// pL3, pL4 et pL5 -> arcs de cercle 		( no box + AXO 4/8 )
//*		pF_31122( 3 )		// pL3, pL4 et pL5, projections	 	( no box + OZ 4/8, de 1  3 ) 
//*		pF_3113()			// 3  approches du cercle complet	 ( no box + AXO 3/8 )
//*		pF_3114( 0.5 )		// cercle immerg dans une pS33		( box + pers, de 0.0  k )
// 312 : CYLINDRE, TORE ET SPHERE
//		pF_312()			// le cylindre, le tore et la sphre	( no box + pers )
// 313 : LIGNES DANS LE TORE
//*		pF_3131( 9 )		// diagonales // immerges dans un tore	( no box + pers )
//*		pF_3132( 16 )		// faisceau de droites immerges dans un tore 	( no box + pers )
//		pF_3133( 16 )		// cercles concentriques immergs dans un tore 	( no box + pers )
//		pF_3134( 8, 1.5 )	// cercle et ses rayons (R<2) dans un tore 	( no box + pers )
// 32 : FORMES COMPOSEES
// 321 : MAILLAGES
// 		pF_3211()			// un pV223 dform
// 322 : SURFACES PRODUITS, SURFACES DE REVOLUTION
//*		pF_3221()			// un vase 		( no box + pers 2/3 )
// 323 : SURFACES TUBULAIRES
//*		pF_3231()			// un tubage granit 
// 324 : SURFACES AFFINES
//		pF_3241()			// cf existant
// 325 : FORMES PARALLELES
//		pF_3251()			// cf existant
// 326 : SURFACES DEVELOPPEES
//		pF_3261()			// a voir plus tard
// 33 : COMBINAISONS LINEAIRES SPECIALES
// 331 : FORMES SYMETRIQUES
//		pF_3311()			// cf existant
// 332 : SURFACES DE COONS
//*		pF_3321()			// surface minimale periodique COONS 	( no box + AXO 3/8 )
//*		pF_3322()			// coquillage COONS						( no box + AXO 7/8 )
//*		pF_3323(4)			// rideau COONS				( no box + PERS 5/6, k=1,2,3,4,... )								
// 34 : CONCATENATIONS, SPLINES
// 341 : SPLINES NON INTERPOLANTES
//		pF_3411()			// cf existant
// 342 : SPLINES INTERPOLANTES
//*		pF_3421( 4 )		// spline interpolante quadrique  (no box + AXO 7/8, k=1,2,3,4,...)
// 343 : LES NURBS
//		pF_3431()		// le cercle NURBS  (no box + AXO 7/8)
// 35 : OPERATEURS DE DEFORMATION
//		pF_351()		// tore immerg dans un cube pV223, cf existant
// 36 : GEOMETRIE DANS LES pFORMES
// 37 : AUTRES OPERATEURS SUR LES pFORMES
// 	macros STRAIGHT AWAY, cf pFbook.inc// 11 : FORMES MULTILINEAIRES RECURSIVES

#macro pF_111() // 4 le_point s
    draw( 0, < 0.00, 0.00, 0.00, 1.0>, le_point(0.1) + ma_texture(MIROIR) )
    draw( 0, < 0.0, 0.0, 0.0, 1.0>, le_point(0.1) + ma_couleur(<1,1,0,0.5>) )
    draw( 0, <-0.5, 0.0, 0.0, 1.0>, le_point(0.1) + ma_texture(GRANIT) )
    draw( 0, < 0.5, 0.0, 0.0, 1.0>, le_point(0.1) + ma_texture(MARBRE) )
    draw( 0, < 0.0, 0.0,-0.5, 1.0>, le_point(0.1) + ma_texture(GOLD) )
    draw( 0, < 0.0, 0.0, 0.5, 1.0>, STANDARD )
#end

#macro pF_112( aspect ) // pL2
    #local p0 = <-0.5,-0.5,-0.5, 1.0> ;
    #local p1 = < 0.5,-0.0,-0.5, 1.0> ;
    #local pL2 = array[2] { p0, p1 }
    #switch (aspect) 
    #case (0) draw( 1, pL2, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0,0>) ) #break
    #case (1) draw( 1, pL2, finesse(1) + le_point(0.03) + ma_couleur(<1,0,0,0>) ) #break
    #case (2) draw( 1, pL2, finesse(2) + le_point(0.03) + ma_couleur(<1,0,0,0>) ) #break
    #case (3) draw( 1, pL2, finesse(3) + le_point(0.03) + ma_couleur(<1,0,0,0>) ) #break
    #case (4) draw( 1, pL2, finesse(0) + courbe(0.02) + ma_couleur(<1,1,0,0>) ) #break
    #end
#end

#macro pF_113( aspect ) // pS22
    #local pL2_0 = array[2] { <-0.5,-0.5,-0.5, 1.0>, < 0.5, 0.0,-0.5, 1.0> }
    #local pL2_1 = array[2] { <-0.5, 0.0, 0.5, 1.0>, < 0.5,-0.5, 0.5, 1.0> }
    #local pS22  = array[2] { pL2_0, pL2_1 }
    #switch (aspect) 
    #case (0) draw( 2, pS22, finesse(<0,0>) + courbe(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (1) draw( 2, pS22, finesse(<1,0>) + courbe(0.02) + ma_couleur(<1,1,0,0>) ) #break
    #case (2) draw( 2, pS22, finesse(<2,0>) + courbe(0.02) + ma_couleur(<1,1,0,0>) ) #break
    #case (3) draw( 2, pS22, finesse(<3,0>) + courbe(0.02) + ma_couleur(<1,1,0,0>) ) #break
    #case (4) draw( 2, pS22, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,0,0>) ) #break
    #case (5) draw( 2, pS22, finesse(<3,3>) + le_point(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (6) draw( 2, pS22, finesse(<3,3>) + normales(0.01,-0.1) + ma_couleur(<1,1,0,0>) ) #break
    #end
#end

#macro pF_114( aspect ) // pV222
    #local pL2_0 = array[2] { <-0.5,-0.5,-0.5, 1.0>, < 0.5, 0.0,-0.5, 1.0> }
    #local pL2_1 = array[2] { <-0.5, 0.0, 0.5, 1.0>, < 0.5,-0.5, 0.5, 1.0> }
    #local pS22  = array[2] { pL2_0, pL2_1 }
    #local pS22_0 = pS22
    #local pS22_1 = pS22    pFtranslate( 2, pS22_1, <0, 0.5,0> ) pFrotate( 2, pS22_1, <0,-15,0> )
    #local pV222 = array[2] { pS22_0, pS22_1 }
    #switch (aspect) 
    #case (0) draw( 3, pV222, finesse(<0,3,3,0>) + feuilles(LISSE) + ma_couleur(<1,1,0,0>) ) #break
    #case (1) draw( 3, pV222, finesse(<1,3,3,0>) + feuilles(LISSE) + ma_couleur(<1,1,0,0>) ) #break
    #case (2) draw( 3, pV222, finesse(<2,3,3,0>) + feuilles(LISSE) + ma_couleur(<1,1,0,0>) ) #break
    #case (3) draw( 3, pV222, finesse(<3,3,3,0>) + feuilles(LISSE) + ma_couleur(<1,1,0,0>) ) #break
    #case (4) draw( 3, pV222, finesse(<2,3,3,0>) + enveloppe(LISSE) + ma_couleur(<1,1,0,0.5>) ) #break
    #case (5) draw( 3, pV222, finesse(<0,3,3,0>) + fibres(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (6) draw( 3, pV222, finesse(<3,3,3,0>) + le_point(0.01) + ma_couleur(<1,0,0,0>) ) #break
    #end
#end

#macro pF_115() // pH2222
    #local pL2_0 = array[2] { <-0.5,-0.5,-0.5, 1.0>, < 0.5, 0.0,-0.5, 1.0> }
    #local pL2_1 = array[2] { <-0.5, 0.0, 0.5, 1.0>, < 0.5,-0.5, 0.5, 1.0> }
    #local pS22  = array[2] { pL2_0, pL2_1 }
    #local pS22_0 = pS22
    #local pS22_1 = pS22    pFtranslate( 2, pS22_1, <0, 0.5,0> ) pFrotate( 2, pS22_1, <0,-15,0> )
    #local pV222 = array[2] { pS22_0, pS22_1 }
    #local pV222_0 = pV222    pFscale( 3, pV222_0, <1.0,1.8,1.0> )
    #local pV222_1 = pV222    pFscale( 3, pV222_1, <0.8,0.8,0.8> )
    #local pH2222 = array[2] { pV222_0, pV222_1 }
    draw( 4, pH2222, finesse(<2,3,3,3>) + le_point(0.01) + ma_couleur(<1,1,0,0>) )
#end
  
// 12 : DIAGONALISATION

#macro pF_121( aspect ) // pS22 et pL3
    #local pL2_0 = array[2] { <-0.5,-0.5,-0.5, 1.0>, < 0.5, 0.0,-0.5, 1.0> }
    #local pL2_1 = array[2] { <-0.5, 0.5, 0.5, 1.0>, < 0.5,-0.5, 0.5, 1.0> }
    #local pS22  = array[2] { pL2_0, pL2_1 }
    #local pL3 = pFdiagonalisation( 2, pS22 )
    draw( 2, pS22, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )
    #switch (aspect) 
    #case (0) draw( 1, pL3, finesse(0) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (1) draw( 1, pL3, finesse(1) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (2) draw( 1, pL3, finesse(2) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (3) draw( 1, pL3, finesse(3) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (4) 
    	draw( 1, pL3, finesse(6) + courbe(0.02) + ma_couleur(<1,1,0,0>) )
    	draw( 1, pL3, finesse(0) + le_point(0.04) + ma_couleur(<1,0,0,0>) ) 
    #break
    #end
#end

#macro pF_122( aspect ) // pS23 et pL4
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS23  = array[2] { pL3_0, pL3_1 }
    #local pL4 = pFdiagonalisation( 2, pS23 )
    #switch (aspect) 
    #case (0) draw( 2, pS23, finesse(<0,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (1) draw( 2, pS23, finesse(<1,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (2) draw( 2, pS23, finesse(<2,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (3) draw( 2, pS23, finesse(<3,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (4) draw( 2, pS23, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) ) #break
    #end
    #switch (aspect) 
    #case (0) draw( 1, pL4, finesse(0) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (1) draw( 1, pL4, finesse(1) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (2) draw( 1, pL4, finesse(2) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (3) draw( 1, pL4, finesse(3) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (4) 
    	draw( 1, pL4, finesse(5) + courbe(0.02) + ma_couleur(<1,1,0,0>) )
    	draw( 1, pL4, finesse(0) + le_point(0.04) + ma_couleur(<1,0,0,0>) ) 
    #break
    #end
#end

#macro pF_123() // pV222, pS23 et pL4
    #local pL2_0 = array[2] { <-0.5,-0.5,-0.5, 1.0>, < 0.5, 0.0,-0.5, 1.0> }
    #local pL2_1 = array[2] { <-0.5, 0.0, 0.5, 1.0>, < 0.5,-0.5, 0.5, 1.0> }
    #local pS22  = array[2] { pL2_0, pL2_1 }
    #local pS22_0 = pS22
    #local pS22_1 = pS22    pFtranslate( 2, pS22_1, <0, 0.5,0> ) pFrotate( 2, pS22_1, <0,-15,0> )
    #local pV222 = array[2] { pS22_0, pS22_1 }
    #local pS23 = pFdiagonalisation( 3, pV222 )
    #local pL4 = pFdiagonalisation( 2, pS23 )
    draw( 3, pV222, finesse(<1,3,3,0>) + enveloppe(LISSE) + ma_couleur(<1,1,0,0.5>) )    
    draw( 2, pS23, finesse(<4,4>) + surface(LISSE) + ma_couleur(<0,1,0,0>) ) 
    draw( 1, pL4, finesse(5) + courbe( 0.02 ) + ma_couleur(<1,0,0,0>) )
#end

#macro pF_124( aspect ) // pS33 et pL5
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
    #local pL5 = pFdiagonalisation( 2, pS33 )
    #switch (aspect) 
    #case (0) draw( 2, pS33, finesse(<0,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (1) draw( 2, pS33, finesse(<1,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (2) draw( 2, pS33, finesse(<2,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (3) draw( 2, pS33, finesse(<3,4>) + courbe(0.01) + ma_couleur(<1,1,0,0>) ) #break
    #case (4) draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) ) #break
    #end
    #switch (aspect) 
    #case (0) draw( 1, pL5, finesse(0) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (1) draw( 1, pL5, finesse(1) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (2) draw( 1, pL5, finesse(2) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (3) draw( 1, pL5, finesse(3) + le_point(0.02) + ma_couleur(<1,0,0,0>) ) #break
    #case (4) 
    	draw( 1, pL5, finesse(5) + courbe(0.02) + ma_couleur(<1,1,0,0>) )
    	draw( 1, pL5, finesse(0) + le_point(0.04) + ma_couleur(<1,0,0,0>) ) 
    #break
    #end
#end

// 13 : GENERALISATION, LES pFORMES

#macro pF_130() // pV333, pS35 et pL7
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
    #local pS33_0 = pS33	pFtranslate( 2, pS33_0, <0,-0.25,0> )
    #local pS33_1 = pS33	pFscale( 2, pS33_1, <1.5,1,1.5> )
    #local pS33_2 = pS33	pFtranslate( 2, pS33_2, <0, 0.25,0> )
	#local pV333 = array[3] { pS33_0, pS33_1, pS33_2 }	
	#local pS35 = pFdiagonalisation( 3, pV333 )	// 3 et (3+3-2)*(2-1)+1 = 5 -> 35
	//#local pS35 = pFstretch( 2, pS35, <-0.1,-0.1,0,1>, <1.1,1.1,0,1> )
	#local pL7 = pFdiagonalisation( 2, pS35 )	// (3+5-2)*(2-1)+1 = 7
//	#local pL7 = pFstretch( 1, pL7, <-0.1,0,0,1>, <1.1,0,0,1> )

    draw( 3, pV333, finesse(<3,3,3,0>) + fibres(0.005) + ma_couleur(<1,1,1,0.5>) )
//	draw( 3, pV333, finesse(<3,3,3,0>) + enveloppe(LISSE) + ma_couleur(<1,1,1,0.8>) )
	//draw( 3, pV333, finesse(<2,3,3,0>) + feuilles(LISSE) + ma_couleur(<1,1,1,0.8>) )
	//draw( 3, pV333, finesse(<3,3,3,0>) + fibres(0.005) + ma_couleur(<1,1,1,0>) )
    draw( 2, pS35, finesse(<2,4>) + surface(LISSE) + ma_couleur(<0,1,0,0.5>) )
    //draw( 2, pS35, finesse(<2,4>) + courbe(0.01) + ma_couleur(<1,1,0,0.5>) )
    draw( 1, pL7, finesse(5) + courbe(0.02) + ma_couleur(<1,0,0,0>) )

    draw( 2, pS35, finesse(<0,0>) + le_point(0.02) + ma_couleur(<1,1,0,0>) )
    //draw( 1, pL7, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1,0>) )
    draw( 1, pL7, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0,0>) )
#end

// 21 : OPERATIONS FONDAMENTALES

#macro pF_212()	// ondulations sur un arc de cercle
	cylinder { <0,-0.5,0>, <0,0.5,0>, 0.5 pigment { color rgb <1,1,1,0.5> } }
	#local arc = quart_cercle_3( 0.5, 1 ) pFrotate( 1, arc, <-90,0,0> )
	#local ond = pLup( arc, 2 )										// 6
	#local n = taille(ond);
	#local i=0; #while (i<n)
		pFtranslate( 0, ond[i], <0,0.5*sin(2*pi*i/(n-1)),0> )		//4
	#local i=i+1; #end
	draw( 1, ond, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) ) 
	draw( 1, ond, finesse(5) + courbe(0.01) + ma_couleur(<1,1,0>) ) 
#end

#macro pF_2131() // pL4 reparamtrise
	#local pL4 = array[4] {	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>,
							< 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> }
	draw( 1, pL4, finesse(0) + le_point(0.05) + ma_couleur(<1,0,0>) )
	draw( 1, pL4, finesse(5) + courbe(0.01) + ma_couleur(<1,0,0>) )
	#local pL4 = pFstretch( 1, pL4, < 1/4,0,0,1>, <3/4,0,0,1> )
	draw( 1, pL4, finesse(0) + le_point(0.05) + ma_couleur(<0,1,0,0.5>) )
	draw( 1, pL4, finesse(5) + courbe(0.02) + ma_couleur(<0,1,0,0.5>) )
#end

#macro pF_2132() // pS35 reparamtrise
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
	draw( 2, pS33, finesse(<0,0>) + le_point(0.02) + ma_couleur(<1,1,0,0.5>) )
	draw( 2, pS33, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )
	#local pS33 = pFstretch( 2, pS33, <1/8,1/8,0,1>, <7/8,7/8,0,1> )
	pFtranslate( 2, pS33, <0,0.01,0> )
	draw( 2, pS33, finesse(<0,0>) + le_point(0.02) + ma_couleur(<1,1,1,0.5>) )
	draw( 2, pS33, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,1,0.5>) )
#end

#macro pF_214( ) // pFgetSubForm, pFgetPoint, pFgetPijk 
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
    draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )
    draw( 2, pS33, finesse(<3,3>) + normales(0.01,-0.05) + ma_couleur(<1,1,0,0.8>) )
   
    #local pL3 = pFgetSubForm( 2, pS33, 1/4 )
    draw( 1, pL3, finesse(5) + courbe(0.02) + ma_couleur(<1/2,1/2,1/2,0>) )
 
    #local p = pFgetPoint( 2, pS33, <1/4,1/4,0,1> )
    draw( 0, p, le_point(0.05) + ma_couleur(<1,0,0,0.5>) )
    
    pSdrawPijk( pS33, <4/6,1/3,0,1>, 0.3, 0.01 )
    pLdrawFrenet( pL3, 1/4, 0.3, 0.01 )
#end

// 22 : IMMERSIONS

// 221 : INTERPOLATION

#macro pF_2211() // pL5 interpolante
	#local pL5 = array[5] {	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>,
		< 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1>, < 1/2,-1/2, 1/2,1> }
	draw( 1, pL5, finesse(0) + le_point(0.05) + ma_couleur(<1,0,0>) )
	#local pL5 = pLinterpolante( pL5 )
	#local pL5 = pFstretch( 1, pL5, <-0.03,0,0,1>, <1.03,0,0,1> )
	draw( 1, pL5, finesse(5) + courbe(0.01) + ma_couleur(<1,1,0>) )
#end

#macro pF_2212() // pS35 interpolante
	#local pL3 = array[3] { <-1/2, 0,-1/2,1>, < 0, 0,-1/2,1>, < 1/2, 0,-1/2,1> }
	#local pL3_0 = pL3 pFtranslate( 1, pL3_0, <0,0,0/4> ) pFtranslate( 0, pL3_0[1], <0,0,-1/4> )
	#local pL3_1 = pL3 pFtranslate( 1, pL3_1, <0,0,1/4> ) pFtranslate( 0, pL3_1[1], <0,-1/4,0> )
	#local pL3_2 = pL3 pFtranslate( 1, pL3_2, <0,0,2/4> ) pFtranslate( 0, pL3_2[2], < 1/8,0,0> )
	#local pL3_3 = pL3 pFtranslate( 1, pL3_3, <0,0,3/4> ) pFtranslate( 0, pL3_3[1], <0, 1/4,0> )
	#local pL3_4 = pL3 pFtranslate( 1, pL3_4, <0,0,4/4> ) pFtranslate( 0, pL3_4[1], <0,0, 1/4> )
	#local pS35 = array[5] { pL3_0, pL3_1, pL3_2, pL3_3, pL3_4 }

	draw( 2, pS35, finesse(<0,0>) + le_point(0.04) + ma_couleur(<1,0,0>) )
	#local pS35 = pSinterpolante( pS35 )
	#local pS35 = pFstretch( 2, pS35, <-0.06,-0.06,0,1>, <1.06,1.06,0,1> )
	draw( 2, pS35, finesse(<4,4>) + surface(LISSE) + ma_texture(MARBRE) )
	#local pL7 = pFdiagonalisation( 2, pS35 )
	#local pL7 = pFstretch( 1, pL7, <-0.3,0,0,1>, <1.01,0,0,1> )
	draw( 1, pL7, finesse(6) + courbe(0.01) + ma_couleur(<1,1,0>) )
#end

#macro pF_2235() // pL3 immerge dans une PS33
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }

	#local p0 = <1/4,1/8,0,1> ; 
	#local p1 = <1/8,3/4,0,1> ; 
	#local p2 = <7/8,2/4,0,1> ;
	#local q0 = (p0+p1)/2 ;
	#local q1 = (p1+p2)/2 ;
	#local r0 = (q0+q1)/2 ;

	#local pL2_0 = array[2] { p0, p1 }
	#local pL2_1 = array[2] { p1, p2 }
	#local pL2_2 = array[2] { (p0+p1)/2, (p1+p2)/2 }
	#local pL3 = array[3] { p0, p1, p2 }
	
	#local ipL2_0 = courbe_in_surface( pL2_0, pS33 )
	#local ipL2_1 = courbe_in_surface( pL2_1, pS33 )
	#local ipL2_2 = courbe_in_surface( pL2_2, pS33 )
	#local ipL3 = courbe_in_surface( pL3, pS33 )
	
	#local ip = pFgetPoint( 2, pS33, p0 ) draw( 0, ip, le_point(0.04) + ma_couleur(<1,0,0,0>) )
	#local ip = pFgetPoint( 2, pS33, p1 ) draw( 0, ip, le_point(0.04) + ma_couleur(<1,0,0,0>) )
	#local ip = pFgetPoint( 2, pS33, p2 ) draw( 0, ip, le_point(0.04) + ma_couleur(<1,0,0,0>) )
	#local ip = pFgetPoint( 2, pS33, q0 ) draw( 0, ip, le_point(0.04) + ma_couleur(<0,1,0,0>) )
	#local ip = pFgetPoint( 2, pS33, q1 ) draw( 0, ip, le_point(0.04) + ma_couleur(<0,1,0,0>) )
	#local ip = pFgetPoint( 2, pS33, r0 ) draw( 0, ip, le_point(0.05) + ma_couleur(<0,0,1,0>) )

    draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) ) 
	draw( 1, ipL2_0, finesse(5) + courbe(0.01) + ma_couleur(<1,1,1,0>) )
	draw( 1, ipL2_1, finesse(5) + courbe(0.01) + ma_couleur(<1,1,1,0>) )
	draw( 1, ipL2_2, finesse(5) + courbe(0.01) + ma_couleur(<1,1,0,0>) )
	draw( 1, ipL3, finesse(5) + courbe(0.02) + ma_couleur(<0,1,0,0>) )

#end

#macro pF_2236() // pL4 immerge dans une PS33
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
	#local p0 = <1/4,1/8,0,1> ; 
	#local p1 = <1/8,3/4,0,1> ; 
	#local p2 = <7/8,2/4,0,1> ;
	#local p3 = <4/8,1/4,0,1> ;

    draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )

    #local ipL2 = courbe_in_surface( array[2] { p0, p1 }, pS33 ) 
	draw( 1, ipL2, finesse(5) + courbe(0.01) + ma_couleur(<1,1,1,0>) )
    #local ipL2 = courbe_in_surface( array[2] { p1, p2 }, pS33 ) 
	draw( 1, ipL2, finesse(5) + courbe(0.01) + ma_couleur(<1,1,1,0>) )
    #local ipL2 = courbe_in_surface( array[2] { p2, p3 }, pS33 ) 
	draw( 1, ipL2, finesse(5) + courbe(0.01) + ma_couleur(<1,1,1,0>) )

    #local ipL4 = courbe_in_surface( array[4] { p0, p1, p2, p3 }, pS33 ) 
	draw( 1, ipL4, finesse(5) + courbe(0.02) + ma_couleur(<0,1,0,0.5>) )
#end

// 23 : INTERFACE

// 231 : TRANSFORMATIONS

#macro pF_2311()	// pFrotate sur une pL4
	#local pL4 = array[4] {	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>,
							< 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> }
	#local N = 24;
	#local i=0; #while (i<N)
		draw( 1, pL4, finesse(6) + courbe(0.03) + ma_couleur(<1,1,0,0>) )
		pFrotate( 1, pL4, <0,360/(N-1),0> )
	#local i=i+1; #end	
#end

#macro pF_2312()	// pFtranslate sur une pL4
	#local pL4 = array[4] {	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>,
							< 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> }
	pFtranslate( 1, pL4, <0,-1/2,0> )
	#local N = 24;
	#local i=0; #while (i<N)
		draw( 1, pL4, finesse(6) + courbe(0.03) + ma_couleur(<1,1,0,0>) )
		pFtranslate( 1, pL4, <0,1/(N-1),0> )
	#local i=i+1; #end	
#end

#macro pF_2313()	// pFscale sur une pL4
	#local pL4 = array[4] {	<-1/2,-1/2,-1/2,1>, < 1/2,-1/2,-1/2,1>,
							< 1/2, 1/2,-1/2,1>, < 1/2, 1/2, 1/2,1> }
	#local N = 24;
	#local i=0; #while (i<N)
		draw( 1, pL4, finesse(6) + courbe(0.03) + ma_couleur(<1,1,0,0>) )
		pFscale( 1, pL4, <0.7,1,0.7> )
	#local i=i+1; #end	
#end


// 3 : COMPOSITIONS

// 31 : FORMES RATIONNELLES

#macro pF_3111()	// les 4 coniques comme projections de pL3
	#local oo = <0,0.5,0,1> ;
	#local p0 = <0.5,0,0,1> ;
	#local p1 = <0.5,0,0.5,1> ;
	#local p2 = <0,0,0.5,1> ;
	#local k = 1/sqrt(2);
	#local eps = 0.01 ;
	
	#macro conic( uu )
		union
		{	#local pL3 = array[3] { p0, k/uu*((1-uu)*oo+uu*p1), p2 }
			draw( 1, pL3, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )
			#local pL3 = pFstretch( 1, pL3, <-k+eps,0,0,1>, <1+k-eps,0,0,1> )
			draw( 1, pL3, finesse(6) + courbe(0.02) + ma_couleur(<1,1,0>) )
		}
	#end
	
	union
		{	cone { <0,0.5,0>, 0, <0,-0.5,0>, 1  pigment { color rgbt <1,1,1,0.5> } }
			draw( 0, oo, le_point(0.03) + ma_couleur(<1,1,1>) )
			#local pL2 = array[2] { oo, p1 }
			#local pL2 = pFstretch( 1, pL2, <-k,0,0,1>, <1+k,0,0,1> )
			draw( 1, pL2, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )	
			conic( 0.500 )	// hyperbole verticale
			conic( 0.707 )	// cercle
			conic( 1.000 )	// parabole
			conic( 1.500 )	// ellipse
			rotate <0,45,0>
		}
#end

#macro pF_31121()	// pL3, pL4 et pL5 -> arcs de cercle
	cylinder { <0,0,-1>, <0,0,1>, 0.5 pigment { color rgbt <1,1,1,0.5> } }
	#local pL3 = quart_cercle_3( 0.5, 1 )	pFtranslate( 1, pL3, <0,0,-0.25> )
	#local pL4 = demi_cercle_4( 0.5 )
	#local pL5 = demi_cercle_5( 0.5 )		pFtranslate( 1, pL5, <0, 0, 0.25> )
	draw( 1, pL3, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )	
	draw( 1, pL3, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1>) )
	draw( 1, pL3, finesse(6) + courbe(0.01) + ma_couleur(<1,1,0>) )
	draw( 1, pL4, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )
	draw( 1, pL4, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1>) )
	draw( 1, pL4, finesse(6) + courbe(0.01) + ma_couleur(<1,1,0>) )
	draw( 1, pL5, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )	
	draw( 1, pL5, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1>) )
	draw( 1, pL5, finesse(6) + courbe(0.01) + ma_couleur(<1,1,0>) )
#end

#macro pF_31122( choix )	// pL3, pL4 et pL5, projections R4->R3 et arcs de cercle 
	cone { <0,0,-0.5>, 0, <0,0,0.5>, 1.0  pigment { color rgbt <1,1,1,0.5> } }
	#local k = 1/sqrt(2);
	#local r = 0.5;
	#local oo = < 0,0,-0.5,1 >;
	#switch (choix)
	#case (1)
	    #local p0 = < r, 0, 0, 1 > ;
	    #local p1 = < r, r, 0, 1 > ;
	    #local p2 = < 0, r, 0, 1 > ;
	    #local uu = k;
	    #local pL = array[3] { p0, k/uu*((1-uu)*oo+uu*p1), p2 }
	    #local arc = array[3] { p0, p1*k, p2 }
	#break
	#case (2)
	    #local p0 = <  r, 0,  0, 1 > ;		// k/uu*((1-uu)*oo+uu*p1) = (2*oo+p1)/3
	    #local p1 = <  r, 2*r,0, 1 > ;		// k/uu*oo -k*oo + k*p1 = 2/3*oo + p1/3
	    #local p2 = < -r, 2*r,0, 1 > ;		// 
	    #local p3 = < -r, 0,  0, 1 > ;
	    //#local uu = ??; k/uu*((1-uu)*oo+uu*p1) doesn't work
	    #local pL = array[4] { p0, 	(2*oo+p1)/3, 
	    							(2*oo+p2)/3, p3 }
	    #local arc = array[4] { p0, p1/3, p2/3, p3 }
	#break
	#case (3)
	    #local p0 = <  r, 0,      0, 1 > ;
	    #local p1 = <  r, r,      0, 1 > ;
	    #local p2 = <  0, 3/2*r,  0, 1 > ;
	    #local p3 = < -r, r,      0, 1 > ;
	    #local p4 = < -r, 0,      0, 1 > ;
	    #local uu = 1/2;
	    #local pL = array[5] { p0, 	k/uu*((1-uu)*oo+uu*p1), 
	    							k/uu*((1-uu)*oo+uu*p2), 
	    							k/uu*((1-uu)*oo+uu*p3), p4 }
	    #local arc = array[5] { p0, p1*k, p2*2/3, p3*k, p4 }
	#break
	#end

	union 
	{	
	#local h = 0.0;
	#switch (choix)
		#case (1)	#local h = 1.0;	#break
		#case (2)	#local h = 0.6;	#break
		#case (3)	#local h = 0.2;	#break
	#end
	draw( 1, pL, finesse(0) + le_point(0.04) + ma_couleur(<0,1,0,0.5>) )	
	draw( 1, pL, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )
	#local pL = pFstretch( 1, pL, <-h,0,0,1>, <1+h,0,0,1> )	
	draw( 1, pL, finesse(6) + courbe(0.02) + ma_couleur(<0,1,0>) )	
	draw( 1, arc, finesse(0) + le_point(0.04) + ma_couleur(<1,0,0,0.05>) )	
	draw( 1, arc, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )	
	#local arc = pFstretch( 1, arc, <-h,0,0,1>, <1+h,0,0,1> )	
	draw( 1, arc, finesse(6) + courbe(0.02) + ma_couleur(<1,0,0>) )
	rotate <0,0,0>	
	}
#end

#macro pF_3113()	// 3  approches du cercle complet
	#local k = 1/sqrt(2) ;
	#local eps = 0.01 ;
//	cylinder { <0,0,-1>, <0,0,1>, 0.5 pigment { color rgbt <1,1,1,0.5> } }
	#local pL3 = quart_cercle_3( 0.5, 1 )	pFtranslate( 1, pL3, <0,0,-1> )
	#local pL4 = demi_cercle_4( 0.5 )
	#local pL5 = demi_cercle_5( 0.5 )		pFtranslate( 1, pL5, <0,0, 1> )

	#local pL3 = pFstretch( 1, pL3, <-5,0,0,1>, <6,0,0,1> )	
	draw( 1, pL3, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )
	draw( 1, pL3, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )
	draw( 1, pL3, finesse(6) + le_point(0.02) + ma_couleur(<1,1,0>) )

	#local pL4 = pFstretch( 1, pL4, <-1,0,0,1>, <2,0,0,1> )	
	draw( 1, pL4, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )
	draw( 1, pL4, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )
	draw( 1, pL4, finesse(6) + le_point(0.02) + ma_couleur(<1,1,0>) )

	#local pL5 = pFstretch( 1, pL5, <-k+eps,0,0,1>, <1+k-eps,0,0,1> )	
	draw( 1, pL5, finesse(0) + le_point(0.03) + ma_couleur(<1,0,0>) )	
	draw( 1, pL5, finesse(0) + courbe(0.01) + ma_couleur(<1,1,1>) )
	draw( 1, pL5, finesse(6) + le_point(0.02) + ma_couleur(<1,1,0>) )
#end

#macro pF_3114( uu )	// cercle immerg dans une pS33
    #local pL3_0 = array[3] { <-0.5,-0.5,-0.5, 1.0>, < 0.0, 0.5,-0.5, 1.0>, < 0.5,-0.5,-0.5, 1.0> }
    #local pL3_1 = array[3] { <-0.5, 0.5,-0.0, 1.0>, < 0.0, 0.5,-0.0, 1.0>, < 0.5,-0.5,-0.0, 1.0> }
    #local pL3_2 = array[3] { <-0.5, 0.5, 0.5, 1.0>, < 0.0,-0.5, 0.5, 1.0>, < 0.5, 0.5, 0.5, 1.0> }
    #local pS33  = array[3] { pL3_0, pL3_1, pL3_2 }
    draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )
	#local pL5 = demi_cercle_5( 0.5 )
    pFtranslate( 1, pL5, <0.5,0.5,0> )
    #local pL5 = pFstretch( 1, pL5, <0-uu,0,0,1>, <1+uu,0,0,1> )
/*    
	#local i=0; #while (i<5)
		#local ip = pFgetPoint( 2, pS33, pL5[i] )
		draw( 0, ip, le_point(0.03) + ma_couleur(<1,0,0>) )
	#local i=i+1; #end

	#local i=0; #while (i<4)
		#local pL2 = array[2]{ pL5[i], pL5[i+1] }
		#local ipL2 = courbe_in_surface( pL2, pS33 )
		draw( 1, ipL2, finesse(6) + courbe(0.01) + ma_couleur(<1,1,1>) )
	#local i=i+1; #end
*/    
	#local ipL5 = courbe_in_surface( pL5, pS33 )
	draw( 1, ipL5, finesse(6) + courbe(0.005) + ma_couleur(<0,1,0>) )	
#end

#macro pF_312()	// le cylindre, le tore et la sphre
	#local R = 0.5;
	#local H = 0.5;
	#local R1 = 0.5;
	#local R2 = 0.25;
// un quart de cylindre de rayon R et de hauteur H:
	#local k = sqrt(2)/2;
	#local pCylindre = array[2] 
	{	array[3] { < R, 0, 0, 1 >, < R, R, 0, 1 >*k, < 0, R, 0, 1 > },
        array[3] { < R, 0, H, 1 >, < R, R, H, 1 >*k, < 0, R, H, 1 > } 
	}
// un seizime de tore de rayons R1 et R2:
	#local R12 = R1+R2;
	#local R2 = abs(R2);
	#local pTore = array[3]     
	{	array[3] { < 0,   0, -R12, 1 >, < 0,  R2, -R12, 1 >*k, < 0,  R2,  -R1, 1 > },
        array[3] { < R12,  0, -R12, 1 >*k, < R12, R2, -R12, 1 >*k*k, <  R1, R2, -R1,  1 >*k },
        array[3] { < R12,  0,  0, 1 >, < R12, R2,  0, 1 >*k, <  R1, R2,  0, 1 > } 
	}
// une huitime de sphre de rayon R:
	#local pSphere = array[3]   
	{	array[3] { < R, 0, 0, 1 >, < R, R, 0, 1 >*k, < 0, R, 0, 1 > },
        array[3] { < R, 0, -R, 1 >*k, < R, R, -R, 1 >*k*k, < 0, R,  0, 1 >*k },
        array[3] { < 0, 0, -R, 1 >, < 0, R, -R, 1 >*k, < 0, R,  0, 1 > } 
	}	
	pFtranslate( 2, pCylindre, <0,0,0.05> )
	pFtranslate( 2, pTore, <0,-0.3,0> )
	pFtranslate( 2, pSphere, <0,0,0> )	
	draw( 2, pCylindre, finesse(<0,0>) + le_point(0.03) + ma_couleur(<1,0,0,0>) )
	draw( 2, pCylindre, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,0,0.5>) )	
	draw( 2, pTore, finesse(<0,0>) + le_point(0.03) + ma_couleur(<1,0,0,0>) )
	draw( 2, pTore, finesse(<3,3>) + surface(LISSE) + ma_couleur(<0,1,1,0.5>) )
	draw( 2, pSphere, finesse(<0,0>) + le_point(0.03) + ma_couleur(<1,0,0,0>) )
	draw( 2, pSphere, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,0,0,0.5>) )
	
	#local diag = pFdiagonalisation( 2, pCylindre )
	#local diag = pFstretch( 1, diag, <-0.2,0,0,1>, <1.2,0,0,1> )
	draw( 1, diag, finesse(6) + courbe(0.01) + ma_couleur(<1,1,1>) )

	#local diag = pFdiagonalisation( 2, pTore )
	#local diag = pFstretch( 1, diag, <-0.2,0,0,1>, <1.2,0,0,1> )
	draw( 1, diag, finesse(6) + courbe(0.01) + ma_couleur(<1,1,1>) )

	#local diag = pFdiagonalisation( 2, pSphere )
	#local diag = pFstretch( 1, diag, <-0.2,0,0,1>, <1.2,0,0,1> )
	draw( 1, diag, finesse(6) + courbe(0.01) + ma_couleur(<1,1,1>) )
#end

#macro pF_3131(N)	// diagonales // immerges dans un tore
	torus { 0.5, 0.25 pigment { color rgbt <1,1,1,0.5> } }	
	#local c2 = demi_cercle_5( 1 )				// chemin dans xOz
	// demi-diagonale 1
	#local c1 = demi_cercle_5( 0.25 ) 			// section dans xOy
	pFtranslate( 1, c1, <0.5,0,0> )
	#local pS33 = cross( c1, c2 )
	#local ipL2_1 = pFdiagonalisation( 2, pS33 )
	// demi-diagonale 2
	#local c1 = demi_cercle_5( 0.25 ) 			// section dans xOy
	pFscale( 1, c1, <-1,-1,1> )
	pFtranslate( 1, c1, <0.5,0,0> )	
	pFrotate( 1, c1, <0,180,0> )
	#local pS33 = cross( c1, c2 )
	#local ipL2_2 = pFdiagonalisation( 2, pS33 )

	#local i=0; #while(i<N)
		union
		{	draw( 1, ipL2_1, finesse(5) + courbe(0.01) + ma_couleur(<1,0,0>) )
			draw( 1, ipL2_2, finesse(5) + courbe(0.01) + ma_couleur(<1,0,0>) )
			rotate <0,360*i/(N-1),0>
		}
	#local i=i+1; #end
#end

#macro pF_3132(N)	// faisceau de droites immerges dans un tore
	torus { 0.5, 0.25 pigment { color rgbt <1,1,1,0.5> } }	
	#local c1 = demi_cercle_4( 0.25 ) 			
	pFtranslate( 1, c1, <0.5,0,0> )		// section dans xOy
	#local c2 = demi_cercle_4( 1 )		// chemin dans xOz
	#local pS33 = cross( c1, c2 )
	pFrotate( 2, pS33, <0,-90,0> )
	#local i=0; #while(i<N)
		#local aa = 2*pi*i/N ;
 		#local pL2 = array[2] {<0,0,0,1>, <cos(aa),sin(aa),0,1> }
 		pFtranslate( 1, pL2, <0.5,0.5,0> )
 		#local ipL2 = courbe_in_surface( pL2, pS33 )
		draw( 1, ipL2, finesse(5) + courbe(0.005) + ma_couleur(<1,1,1>) )
	#local i=i+1; #end
#end

#macro pF_3133( N )	// cercles concentriques immergs dans un tore
//	torus { 0.5, 0.249 pigment { color rgbt <1,1,1,0.5> } }
	#local c1 = demi_cercle_4( 0.25 ) 
	pFtranslate( 1, c1, <0.5,0,0> )		// section dans xOy
	#local c2 = demi_cercle_4( 1 )		// chemin dans xOz
	#local pS33 = cross( c1, c2 )
	pFrotate( 2, pS33, <0,-90,0> )
    draw( 2, pS33, finesse(<3,3>) + le_point(0.005) + ma_couleur(<1,1,1,0>) )
	#local i=0; #while (i<N)
		#local uu = i/(N-1);
		#local pL5 = demi_cercle_4( (1-uu)*0.05 + uu*1.0 )
		#local pL5_up = pL5
		#local pL5_down = pL5
    	pFrotate( 1, pL5_up, <0,0,180> )
    	pFtranslate( 1, pL5_up, <0.5,0.5,0> )
     	pFtranslate( 1, pL5_down, <0.5,0.5,0> )
 		#local ipL5_up = courbe_in_surface( pL5_up, pS33 )
		#local ipL5_down = courbe_in_surface( pL5_down, pS33 )
		draw( 1, ipL5_up, finesse(5) + courbe(0.01) + ma_couleur(<1,uu,0>) )
		draw( 1, ipL5_down, finesse(5) + courbe(0.01) + ma_couleur(<1,uu,0>) )
	#local i=i+1; #end
#end

#macro pF_3134( N, R )	// cercle et ses rayons (R<2) dans un tore
	torus { 0.5, 0.25 pigment { color rgbt <1,1,1,0.5> } }	

	#local c1 = demi_cercle_4( 0.25 ) 			
	pFtranslate( 1, c1, <0.5,0,0> )		// section dans xOy
	#local c2 = demi_cercle_4( 1 )		// chemin dans xOz
	#local pS33 = cross( c1, c2 )
	pFrotate( 2, pS33, <0,-90,0> )
    //draw( 2, pS33, finesse(<3,3>) + le_point(0.005) + ma_couleur(<1,1,1,0>) )

	#local pL5 = demi_cercle_5( R )
	#local pL5_up = pL5
	#local pL5_down = pL5
	pFrotate( 1, pL5_up, <0,0,180> )
	pFtranslate( 1, pL5_up, <0.5,0.5,0> )
 	pFtranslate( 1, pL5_down, <0.5,0.5,0> )
	#local ipL5_up = courbe_in_surface( pL5_up, pS33 )
	#local ipL5_down = courbe_in_surface( pL5_down, pS33 )
	draw( 1, ipL5_up, finesse(4) + le_point(0.01) + ma_couleur(<1,0,0>) )
	draw( 1, ipL5_down, finesse(4) + le_point(0.01) + ma_couleur(<1,0,0>) )

	#local i=0; #while(i<N)
		#local aa = 2*pi*i/N ;
 		#local pL2 = array[2] {<0,0,0,1>, <R*cos(aa),R*sin(aa),0,1> }
 		pFtranslate( 1, pL2, <0.5,0.5,0> )
 		#local ipL2 = courbe_in_surface( pL2, pS33 )
		draw( 1, ipL2, finesse(5) + courbe(0.01) + ma_couleur(<1,1,0>) )
	#local i=i+1; #end

#end

#macro pF_3221()	// un vase		( no box + pers 2/3 )
	#local k = 1/sqrt(2);
	#local c1 = array[7] { 	<0.01,-0.50,0,1>,
							<0.10,-0.50,0,1>,
							<0.50,-0.50,0,1>,
							<0.50,-0.25,0,1>,
							<0.10, 0.00,0,1>,
							<0.10, 0.50,0,1>,
							<0.15, 0.50,0,1>
						} 	// section dans xOy		
	#local c2 = demi_cercle_5( 1 )		// chemin dans xOz
	#local c2 = pFstretch( 1, c2, <-k,0,0,1>, <1+k,0,0,1> )
	#local pS33 = cross( c1, c2 )
	pFtranslate( 0, pS33[6][2], < 0,-0.5,0> ) // poigne et bec verseur
  	pFrotate( 1, c1, <0,180,0> )
  	draw( 1, c1, finesse(6) + courbe(0.01) + ma_couleur(<1,0,0,0>) )
 	pFrotate( 2, pS33, <0,-90,0> )
   	draw( 2, pS33, finesse(<4,4>) + surface(LISSE) + ma_texture(MARBRE) )
   	object { plane { <0,1,0>, -1/2 } une_texture( GRANIT ) }
#end
 
#macro pF_3231()
	#local che = array[6] { <-0.5,-0.5,-0.5,1>, < 0.5,-0.5,-0.5,1>, 
							< 0.5, 0.5,-0.5,1>, < 0.5, 0.5, 0.5,1>, 
							<-0.5, 0.5, 0.5,1>, <-0.5,-0.5, 0.5,1>}
	#local sec = array[4] {	<-0.1,-0.1,0,1>, < 0.1,-0.1,0,1>, 
							<-0.1, 0.1,0,1>, < 0.1, 0.1,0,1> }
	pFscale( 1, sec, <2,2,2> )
	#local tub = pipe(che, sec, 4, 3)
	draw( 2, tub, surface(LISSE) + ma_texture( GRANIT ) )
	draw( 1, che, finesse(4) + repere(0.005,0.1) )
	draw( 1, che, finesse(4) + le_point(0.02) + ma_couleur( <1,1,1,> ) )
#end
 
#macro pF_3321()	// surface minimale periodique COONS
	#local p0 = <-1/2,-1/2,-1/2,1> + <0,1/2,-1/2> ;
	#local p1 = <-1/2, 1/2,-1/2,1> + <0,1/2,-1/2> ;
	#local p2 = <-1/2, 1/2, 1/2,1> + <0,1/2,-1/2> ;
	#local p3 = <-1/2,-1/2,-0/2,1> + <0,1/2,-1/2> ;
	#local p4 = <-0/2,-0/2, 1/2,1> + <0,1/2,-1/2> ;
	#local p5 = <-1/2,-0/2, 1/2,1> + <0,1/2,-1/2> ;
	#local p6 = <-0/2,-1/2,-0/2,1> + <0,1/2,-1/2> ;
	#local p7 = <-0/2,-0/2,-0/2,1> + <0,1/2,-1/2> ;
	#local p8 = <-0/2,-0/2, 1/2,1> + <0,1/2,-1/2> ;
	#local L1 = array[6] { p0, p1, p1, p1, p1, p2 }	// approche d'un coin carr
	#local L2 = array[3] { p6, p7/sqrt(2), p8 }		// arc de cercle
	#local L3 = array[3] { p0, p3, p6 }				// arc de parabole
	#local L4 = array[3] { p2, p5, p8 }				// arc de parabole
	#local coons = creer_coons( L3, L4, L1, L2 )
		#local i=0; #while (i<2)
		#local j=0; #while (j<4)
		union
		{	draw( 2, coons, finesse(<3,2>) + surface(LISSE) + ma_texture(GRANIT) )
			draw( 1, L1, finesse(4) + le_point(0.02) + ma_couleur( < 0,0,1/2 > ) )
			draw( 1, L2, finesse(4) + le_point(0.02) + ma_couleur( < 0,0,1/2 > ) )
			draw( 1, L3, finesse(4) + le_point(0.02) + ma_couleur( < 1/2,0,0 > ) )
			draw( 1, L4, finesse(4) + le_point(0.02) + ma_couleur( < 1/2,0,0 > ) )
			rotate <90*j,0,0>
			#if (i=1) scale <-1,1,1> #end
		}
		#local j=j+1; #end		
		#local i=i+1; #end
#end

#macro pF_3322()	// coquillage COONS
	#local L1 = array[3] { <0.0,0.0,-0.5,1>, <0.0,0.25,-0.5,1>/sqrt(2), <0.0,0.25,-0.1,1> }
	#local L2 = array[3] { <0.5,0.0, 0.0,1>, <0.5,0.25, 0.0,1>/sqrt(2), <0.1,0.25, 0.0,1> }
	#local L3 = array[3] { <0.0,0.25,-0.1,1>, <0.1,0.25,-0.1,1>/sqrt(2), <0.1,0.25,0.0,1> }
	#local L4 = array[3] { <0.0,0.0,-0.5,1>, <0.5,0.0,-0.5,1>/sqrt(2), <0.5,0.0,0.0,1> }

	#local L4 = pLup( L4, 6 )										//4,6
	#local n = taille(L4);
	#local i=0; #while (i<n)
		pFtranslate( 0, L4[i], <0,0.25*sin(4*pi*i/(n-1)),0> )		//2,4
	#local i=i+1; #end

	#local coons = creer_coons( L1, L2, L3, L4 )
	#local j=0; #while (j<2)
	#local i=0; #while (i<4)
	union
	{	draw( 2, coons, finesse(<3,3>) + surface(LISSE) + ma_texture(MARBRE) )
		#local diag = pFdiagonalisation( 2, coons )
		draw( 1, diag, finesse(4) + courbe(0.005) + ma_couleur( < 1,1,1 > ) )
		//draw( 1, L1, finesse(4) + le_point(0.005) + ma_couleur( < 0,0,1/2 > ) )
		//draw( 1, L2, finesse(4) + le_point(0.005) + ma_couleur( < 0,0,1/2 > ) )
		draw( 1, L3, finesse(4) + courbe(0.005) + ma_couleur( < 1/2,0,0 > ) )
		draw( 1, L4, finesse(4) + courbe(0.005) + ma_couleur( < 1/2,0,0 > ) )
		rotate <0,90*i,0>
		#if (j=1)
			scale <-1,-1,1>
			translate <0,-0.05,0>
		#end
	}
	#local i=i+1; #end		
	#local j=j+1; #end		
#end

#macro pF_3323( k )	// rideau COONS		( no box + PERS 5/6, k=1,2,3,4,... )
	#local L1 = creer_ligne( 4*k+1, 1 )
	#local L2 = L1
	#local n = taille(L2);
	#local i=0; #while (i<n)
		pFtranslate( 0, L2[i], <0,0,0.125*sin(2*k*pi*i/(n-1))> )
	#local i=i+1; #end
	pFtranslate( 1, L1, <0,0.5,0> )
	pFtranslate( 1, L2, <0,-0.5,0> )
	#local L3 = array[3] {<-0.5,0.5,0,1>, <-0.5,0,-0.125,1>, <-0.5,-0.5,0,1> }
	#local L4 = array[3] {< 0.5,0.5,0,1>, < 0.5,0, 0.125,1>, <0.5,-0.5,0,1> }
	#local L2 = pLinterpolante( L2 )	
	#local coons = creer_coons( L1, L2, L3, L4 )
	#local diag = pFdiagonalisation( 2, coons )
	union {
	draw( 1, L2, finesse(6) + le_point(0.01) + ma_couleur(<1,1,0,0>) )
	draw( 2, coons, finesse(<3,3>) + surface(LISSE) + ma_texture(MARBRE) )
	draw( 1, diag, finesse(6) + courbe(0.01) + ma_couleur( <0,1,0> ) )
	translate <0,0,-0.25>
	}
	union {
	draw( 1, L2, finesse(6) + le_point(0.01) + ma_couleur(<1,1,0,0>) )
	draw( 2, coons, finesse(<3,3>) + surface(LISSE) + ma_texture(GRANIT) )
	draw( 1, diag, finesse(6) + courbe(0.01) + ma_couleur( <0,1,0> ) )
	translate <0,0,0.25>
	}
#end

#macro pF_3421( k ) // spline interpolante quadrique  (no box + AXO 7/8, k=1,2,3,4,...)
	#local curv = creer_ligne( 4*k+1, 1.5 )
	#local n = taille(curv);
	#local i=0; #while (i<n)
		pFtranslate( 0, curv[i], <0,0.125*sin(2*k*pi*i/(n-1)),0> )
	#local i=i+1; #end
	// tracer les le_point s nodaux:
	draw( 1, curv, finesse(0) + le_point(0.03) + ma_couleur(<1,1,1>) )
	draw( 1, curv, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1>) )
	// tracer une pL interpolante
	#local spi = pLinterpolante( curv )	
	draw( 1, spi, finesse(6) + le_point(0.01) + ma_couleur(<0,1,0,0>) )
	// tracer une spline interpolante ; ATTENTION: spi est un tableau de paraboles !!
	#local b_1 = curv[0] ; // 2*curv[0]-curv[1];
	#local spi = spline_interpolante_quadrique( b_1, curv, false )
	#local i=0; #while (i<taille(spi))
		draw( 1, spi[i], finesse(5) + le_point(0.01) + ma_couleur(<0,0,1,0>) )
	#local i=i+1; #end	
#end

#macro pF_3431() 	// le cercle NURBS  (no box + AXO 7/8)
	#local curv = array[5] 
	{ <0.5,0.0,0.0,1>, <0.0,0.5,0.0,1>, <-0.5,0.0,0.0,1>, <0.0,-0.5,0.0,1>, <0.5,0.0,0.0,1> }
	#local b_1 = <0.5,-0.5,0.0,1>;
	// tracer les le_point s nodaux:
	draw( 1, curv, finesse(0) + le_point(0.04) + ma_couleur(<1,1,1,0.5>) )
	draw( 1, curv, finesse(0) + courbe(0.005) + ma_couleur(<1,1,1>) )
	draw( 0, b_1, le_point(0.04) + ma_couleur(<1,1,0,0>) )
	// tracer la spline quadrique interpolante (ATTENTION: spi est un tableau de paraboles)
	#local spi = spline_interpolante_quadrique( b_1, curv, true )
	#local i=0; #while (i<taille(spi))
		draw( 1, spi[i], finesse(5) + courbe(0.01) + ma_couleur(<1,0,0,0>) )
	#local i=i+1; #end
#end

/////////////////// MACROS STRAIGHT AWAY ////////////////////

#macro geos( R, r, N )
	#local c1 = demi_cercle_5( r )
	#local c2 = demi_cercle_5( 1 )
	pFtranslate( 1, c1, <R,0,0> ) 
	#local pTore = cross( c1, c2 )
	#local hu = sqrt(2)/2*0.8 ;
	#local hv = sqrt(2)/2*0.8 ;
	#local pTore = pFstretch( 2, pTore, <-hu,-hv,0,1>, <1+hu,1+hv,0,1> )
	pFscale( 2, pTore, <1,-1,1> )
//	pFrotate( 2, pTore, <0,-90,0> )
	draw ( 2, pTore, finesse( <4,5> ) + surface(LISSE) + ma_couleur(<1,1,0,0.7>) ) // ma_texture(MARBRE)
	//torus { 0.5, 0.25*0.99 pigment { color rgb <1,1,1,0.8> } }
	#local i=0; #while (i<N)
		#local uu = i/(N-1);
		#local aa = -0*(1-uu) + 90*uu;
		#local geo = geodesique( pTore, <0,0,0,1>, aa, 140, 1/100 ) // 150
		draw( 1, geo, finesse(0) + courbe( 0.005 ) + ma_couleur( <1-uu,uu,0> ) )
		tracer_normales_geodesique( geo, 0.05, 0.003 )
	//	#local seg = array[2] {<0,0,0,1>, <1,0,0,1>}
	//	pFrotate( 1, seg, <0,0,aa> )
	//	#local iseg = courbe_in_surface( seg, pTore )
	//	draw( 1, iseg, finesse(5) + courbe( 0.005 ) + ma_couleur( <1-uu,uu,0> ) )
	#local i=i+1; #end
#end

//geos( 1/2, 1/4, 16 )	// 4 , 8, 16, 24

#macro trefoil_knot( R, r )
	// object { torus { R, r*0.99 } une_couleur(<1,1,1,0.6>) }
	// construction d'un quart de tore (profil et section demi_cercles):
	#local pProfil = arc_cercle( 5, r)	
	pFtranslate( 1, pProfil, <R,0,0> )
	#local pChemin = arc_cercle( 5, 1)
	#local pSurf = cross( pProfil, pChemin )
	// reparametrisation de la portion de tore de 180  120 :
	#local pSurf = pFstretch( 2, pSurf, <0,0,0,1>, <1,2/3*0.99,0,1> )
	#local pCourb = pFdiagonalisation( 2, pSurf )	
	// construction des diagonales et des portions de tore:
	#local aaa = array[6] { <0,0,0>, <0,120,0>, <0,120,0>, <180,0,0>, <0,120,0>, <0,120,0> }
	#local cc1 = array[6] { <1,0,0,0.6>, <0,1,0,0.6>, <0,0,1,0.6>, <1,1,0,0.6>, <1,0,1,0.6>, <0,1,1,0.6> }
	#local cc2 = array[6] { <1,0,0>, <0,1,0>, <0,0,1>, <1,1,0>, <1,0,1>, <0,1,1> }
	#local i=0; #while (i<6)
		pFrotate( 2, pSurf, aaa[i] )
		pFrotate( 1, pCourb, aaa[i] )
		draw( 2, pSurf, finesse( <3,4> ) + surface( LISSE ) + ma_texture( MARBRE ) ) // ma_couleur( cc1[i] ) )
		draw( 1, pCourb, finesse(4) + courbe( 0.02 ) + ma_couleur( cc2[i] ) )
	#local i=i+1; #end
#end

//trefoil_knot( 1/2, 1/4 )

#macro trefoil_knot_geo( R, r )
	// object { torus { R, r*0.99 } une_couleur(<1,1,1,0.6>) }
	#local pProfil = arc_cercle( 5, r)	
	pFtranslate( 1, pProfil, <R,0,0> )
	#local pChemin = arc_cercle( 5, 1)
	#local pSurf = cross( pProfil, pChemin )
	// reparametrisation de la portion de tore de 180  120 :
	#local pSurf = pFstretch( 2, pSurf, <0,0,0,1>, <1,2/3*0.99,0,1> )
//	#local pCourb = pFdiagonalisation( 2, pSurf )
	#local geo = geodesique( pSurf, <0,0,0,1>, 70.5, 81, 1/100 )
	#local aaa = array[6] { <0,0,0>, <0,120,0>, <0,120,0>, <180,0,0>, <0,120,0>, <0,120,0> }
	#local cc1 = array[6] { <1,0,0,0.7>, <0,1,0,0.7>, <0,0,1,0.7>, <1,1,0,0.7>, <1,0,1,0.7>, <0,1,1,0.7> }
	#local cc2 = array[6] { <1,0,0,0>, <0,1,0,0>, <0,0,1,0>, <1,1,0,0>, <1,0,1,0>, <0,1,1,0> }
	#local i=0; #while (i<6)
		pFrotate( 2, pSurf, aaa[i] )
		draw( 2, pSurf, finesse( <3,3> ) + surface( LISSE ) + ma_couleur( cc1[i] ) )
	//	pFrotate( 1, pCourb, aaa[i] )
	//	draw( 1, pCourb, finesse(3) + courbe( 0.01 ) + ma_couleur( cc2[i] ) )
		pFrotate( 1, geo, aaa[i] )
		draw( 1, geo, finesse(0) + courbe( 0.01 ) + ma_couleur( cc2[i] ) )
	//	tracer_normales_geodesique( geo, 0.1, 0.005 )
	#local i=i+1; #end
#end

//trefoil_knot_geo( 1/2, 1/4 )

#macro arcs_struct( R, r, N )
	#local pProfil = arc_cercle( 5, r)	
	pFtranslate( 1, pProfil, <R,0,0> )
	#local pChemin = arc_cercle( 5, 1)
	#local pSurf = cross( pProfil, pChemin )
	#local k=sqrt(2)/2;
	#local u0 = 1/8;
	#local u1 = 5/8;
	#local pSurf = pFstretch( 2, pSurf, <u0,-k,0,1>, <u1,1+k,0,1> )
	#local meridien = array[5] { pSurf[0][0], pSurf[1][0], pSurf[2][0], pSurf[3][0], pSurf[4][0] }
	draw( 2, pSurf, finesse( <3,5> ) + surface( LISSE ) + ma_couleur( <1,1,0,0.8> ) )
	#local geo1 = geodesique( pSurf, <0,0,0,1>, 75, 60, 1/200 )	// 60, 75
	#local geo2 = geo1	
	pFscale( 1, geo2, <-1,1,1> )
	#local aaa = 360/N;
	#local i=0; #while (i<N)
		pFrotate( 1, geo1, <0,aaa,0> )
		pFrotate( 1, geo2, <0,aaa,0> )
		pFrotate( 1, meridien, <0,aaa,0> )
		#local uu = i/(N-1);
		draw( 1, geo1, finesse(0) + courbe( 0.01 ) + ma_couleur( <1,0,0> ) )
		draw( 1, geo2, finesse(0) + courbe( 0.01 ) + ma_couleur( <0,1,0> ) )
		draw( 1, meridien, finesse( 3 ) + courbe( 0.005 ) + ma_couleur( <1,1,0> ) )
	//	tracer_normales_geodesique( geo1, 0.05, 0.003 )
	//	tracer_normales_geodesique( geo2, 0.05, 0.003 )
	#local i=i+1; #end
#end

//arcs_struct( 0.4, 0.5, 32 )	// 1, 16, 32
//union { arcs_struct( 0.4, 0.5, 32 ) translate <0,-1.1,0> rotate <90,0,0> } 

#macro arcs_diag( R, r )
	object { torus { R, r*0.99 } une_couleur(<1,1,1,0.6>) }
	#local pProfil = arc_cercle( 5, r)	
	pFtranslate( 1, pProfil, <R,0,0> )
	#local pChemin = arc_cercle( 5, 1)
	#local pSurf = cross( pProfil, pChemin )
	#local pSurf = pFstretch( 2, pSurf, <0,0,0,1>, <1,2/3*0.99,0,1> )
//	draw( 2, pSurf, finesse( <3,3> ) + surface( LISSE ) + ma_couleur( <1,1,1> ) )
	#local diag1 = pFdiagonalisation( 2, pSurf )
	#local diag2 = diag1
	pFscale( 1, diag2, <1,1,-1> )

	#local N = 12;	// 24
	#local aaa = 360/(N-1);
	#local i=0; #while (i<N)
		pFrotate( 1, diag1, <0,aaa,0> )
		pFrotate( 1, diag2, <0,aaa,0> )
		draw( 1, diag1, finesse(3) + repere( 0.005, 0.05 ) + ma_couleur( <1,0,0> ) )
		draw( 1, diag2, finesse(3) + repere( 0.005, 0.05 ) + ma_couleur( <0,1,0> ) )
	#local i=i+1; #end
#end

//arcs_diag( 1/2, 1/4 )

#macro opening_torus( N )
	#local k = sqrt(2)/2;
	#macro demi_cercle( r )		// retourne un tableau de 5 le_point s
		array[5] {	<  r, 0, 	0, 1 >,
					<  r, r, 	0, 1 >*k,
					<  0, 3/2*r,0, 1 >*2/3,
					< -r, r, 	0, 1 >*k,
					< -r, 0, 	0, 1 > }	
	#end
	#macro pTore( R, r, h )
		#local pL5_profil = demi_cercle( r )	
		pFtranslate( 1, pL5_profil, <R,0,0> )
		#local pL3_chemin = demi_cercle( 1 )
		#local pS55 = cross( pL5_profil, pL3_chemin )
		pFstretch( 2, pS55, <-h,-h,0,1>, <1+h,1+h,0,1> )
	#end
	#local i=0; #while (i<N)
		#local uu = i/(N-1);
		#local tore = pTore( 1/2, 1/4-0.2*uu, k*uu )
		pFscale( 2, tore, <1,-1,1> )
		draw( 2, tore, finesse(<3,5>)+surface(LISSE)+ma_couleur(<1-uu,uu,0,0.5>))
	#local i=i+1; #end
#end

//opening_torus( 8 )

// controles pour claude
#macro pavage( surf )
	#local j=0; #while (j<2)
	#local i=0; #while (i<3)
		#local frise = array[3] { <0,0,0,1>, <0,1/4,0,1>, <1/4,1/2,0,1> }
		#local _frise = array[3] { <1/2,0,0,1>, <1/2,1/4,0,1>, <1/4,1/2,0,1> } 	
		pFtranslate( 1, frise, <i/4,j/2,0>)
		pFtranslate( 1, _frise, <i/4,j/2,0>)
		#local ifrise = courbe_in_surface( frise, surf )
		#local i_frise = courbe_in_surface( _frise, surf )
		draw( 1, ifrise, finesse(3)+courbe(0.01)+ma_couleur(<0,1,0>) )
		draw( 1, i_frise, finesse(3)+courbe(0.01)+ma_couleur(<0,1,0>) )
	#local i=i+1; #end
	#local j=j+1; #end	
#end

#macro figure( surf )
	#local fig = demi_cercle_5( 1/4 )
	pFtranslate( 1, fig, <1/2,0.5,0> )
	#local fig = pFstretch( 1, fig, <-1/2,0,0,1>, <1.5,0,0,1> )
	#local ifig = courbe_in_surface( fig, surf )
	draw( 1, ifig, finesse(3)+courbe(0.02)+ma_couleur(<1,0,0>) )
	#local fig = demi_cercle_5( 1/8 )
	pFscale( 1, fig, <1,-1,1> )
	pFtranslate( 1, fig, <1/2,0.75,0> )
	#local fig = pFstretch( 1, fig, <-1/2,0,0,1>, <1.5,0,0,1> )
	#local ifig = courbe_in_surface( fig, surf )
	draw( 1, ifig, finesse(3)+courbe(0.02)+ma_couleur(<1,0,0>) )
#end

#macro chapiteau( avec_chapiteau, avec_pavage, avec_figure )

	#if (avec_chapiteau)
		#local profil = array[4] { <0,-1/2,0,1>,<1/4,-1/2,0,1>,<1/4,1/2,0,1>,<1,1/2,0,1> }
		pFscale( 1, profil, <1,1/2,1> )
		pFtranslate( 1, profil, <1/4,0,0> )
		#local section = array[3] { <1,0,0,1>, <1,1,0,1>/sqrt(2), <0,1,0,1> }
		#local chap = cross( profil, section )
	#else
		#local chap = array[2] 
		{	array[2] { <0,0,0,1>, < 1,0,0,1> }
			array[2] { <0,0,1,1>, < 1,0,1,1> }
		}
	//	pFtranslate( 2, chap, <1/4,0,1/4> )
		pFscale( 2, chap, <-1,1,-1> )
	#end
	union
	{
		draw( 2, chap, finesse(<3,3>)+surface(LISSE)+ma_couleur(<0.9,0.8,0.5>) )
		#if (avec_pavage)
			pavage( chap )	
		#end
		#if (avec_figure) 
			figure( chap )
		#end
		rotate <0,-90,0>
	}
#end

//chapiteau( true, true, true )
//chapiteau( false, true, true )

// controle pour claude, parabole interpolante
/*
#local b0 = <-1/2,-1/2,0,1>;
#local b1 = <0,1/4,0,1>;
#local b2 = <1/2,-1/2,0,1>;
draw(0,b0,STANDARD) 
draw(0,b1,STANDARD)
draw(0,b2,STANDARD)
#local p0 = b0;
#local p1 = (-b0+4*b1-b2)/2;
#local p2 = b2;

#local pL3 = array[3] { p0, p1, p2 }
#local pL3 = pFstretch( 1, pL3, <-0.03,0,0,1>, <1.03,0,0,1> )
draw( 1, pL3, finesse(4)+courbe(0.02)+ma_couleur(<1,1,1>) )
*/

#macro test_parisel()
	// une polyligne : 
	#local c1 = array[5] { <1,0,0,1>, <1,1,0,1>, <0,3/2,0,1>, <-1,1,0,1>, <-1,0,0,1> }
	
	// le profil d'extrusion, un simple segment :
	#local c2 = array[2] { 	<1,-1/2,0,1>, <1,1/2,0,1> }
	
	// le prisme :
	#local pPrisme = cross( c2, c1 )
	draw( 2, pPrisme, finesse(<1,0>) + surface(LISSE) + ma_couleur(<1,1,1,0.5>) )
	
	// et les deux gnratrices :
	pFrotate( 1, c1, <90,0,0> )			// pour voir la polyligne verte en bonne position
	draw( 1, c1, finesse(0) + courbe(0.01) + ma_couleur(<0,1,0,0>) )
	draw( 1, c2, finesse(0) + courbe(0.01) + ma_couleur(<1,0,0,0>) )		// rouge
#end

// macro calculant la distance d'une le_point  une pSurface
// attention aux limites de la surface pouvant fausser le rsultat
// tendre ventuellement par pFstretch()

#macro dist_ij( p, pSurface )
	#local imin = 0;											// intitialisation de
	#local jmin = 0;											// de imin et jmin
	#local pmin = pSurface[0][0];			 				// et de pmin dans R4 sur la surface
	#local dv = <pmin.x/pmin.t, pmin.y/pmin.t, pmin.z/pmin.t> - p;	// vecteur initial dans R3
	#local d2min = vdot( dv, dv );						// produit scalaire = carre de la longueur
	#local i=0; #while (i<taille(pSurface))
		#local j=0; #while (j<taille(pSurface[0]))
			#local pij = pSurface[i][j];												// le le_point courant dans R4
			#local dv = <pij.x/pij.t, pij.y/pij.t, pij.z/pij.t> - p;	// le vecteur courant dans R3
			#local d2 = vdot( dv, dv );												// produit scalaire courant
			#if (d2<d2min)										// si inferieur
				#local imin = i;								// on actualise imin et jmin
				#local jmin = j;
				#local d2min = d2;								// et le carre de la longueur
			#end
		#local j=j+1; #end
	#local i=i+1; #end
	<imin, jmin, sqrt(d2min)>								// retourne vecteur contenant imin, jmin et la distance
#end

#macro test_distance( N )
	#local pSurface = creer_facette( 3, 3, 1 )
	#local pSurface = surface_aleatoire( pSurface, 3, 0.5 )
	#local pSurface = pFsubdivision( 2, pSurface, <4,4,0,0> )
	#local i=0; #while (i<N)
		#local uu = -0.4*(1-i/(N-1))+0.4*i/(N-1);
		#local vv =  0;	//0.4*(1-i/(N-1))-0.4*i/(N-1);
		#local ww = -0.4*(1-i/(N-1))+0*i/(N-1);
		#local P = <uu,vv,ww>;
		#local D = dist_ij( P, pSurface );
		#local pij = pSurface[D.x][D.y];
		object { cylinder { P, <pij.x/pij.t, pij.y/pij.t, pij.z/pij.t>, 0.002 } une_couleur( <0,1,0> ) }
		object { sphere { P, 0.02 } une_couleur( <1,0,0> ) }
		#debug concat( "\n distance : ", str( D.z, 4,4 ), "\n" )
	#local i=i+1; #end
	draw( 2, pSurface, surface(LISSE) + ma_couleur(<1,1,1>))
#end
//test_distance( 20 )

#macro surface_in_surface_and_diag( choix )
	#local pSurface = creer_facette( 2, 2, 1 )
	#local pSurface = _surface_aleatoire( pSurface, 3, <0.1,0.1,1.0> )
	#debug "\n affichage pSurface : "
	draw( 2, pSurface, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,1,0.5>))
	#switch ( choix )
		#case (1)
			#local ipSurface = array[2] { 	array[2] { <1/8,7/8,0,1>, <1/8,1/8,0,1> }, 
									array[2] { <1/8,1/8,0,1>, <7/8,1/8,0,1> } }
		#break
		#case (2)
			#local ipSurface = array[2] { 	array[3] { <1/8,7/8,0,1>, <2/8,3/8,0,1>, <7/8,7/8,0,1> }, 
									array[3] { <1/8,1/8,0,1>, <6/8,5/8,0,1>, <7/8,1/8,0,1> } }
		#break
		#case (3)
			#local ipSurface = array[3] { 	array[3] { <1/8,7/8,0,1>, <2/8,3/8,0,1>, <7/8,7/8,0,1> },
									array[3] { <1/8,4/8,0,1>, <2/8,4/8,0,1>, <7/8,4/8,0,1> }, 
									array[3] { <1/8,1/8,0,1>, <6/8,5/8,0,1>, <7/8,1/8,0,1> } }
		#break
	#end
	#debug "\n calcul ipSurface :\n "
	#local pSurface_E = _pFimmersion( 2, ipSurface, 2, pSurface )
	#debug "\n affichage ipSurface :\n "
	draw( 2, pSurface_E, finesse(<3,3>) + surface(LISSE) + ma_couleur(<1,1,0>))
	#debug "\n calcul diag :\n "
	#local idiag = pFdiagonalisation( 2, ipSurface )
	#debug "\n immersion diag :\n "
	#local diag = _pFimmersion( 1, idiag, 2, pSurface )
	#debug "\n affichage diag :\n "
	draw( 1, diag, finesse(4) + courbe(0.005) + ma_couleur(<1,0,0>) )
#end

// surface_in_surface_and_diag( 3 )


///////////////////////////////////////////////////////////////
// 0 :  RAPPELS DE GEOMETRIE
// 01 : GEODESIQUES
// 1 :  CONSTRUCTION, DEFINITION
// 11 : FORMES MULTILINEAIRES RECURSIVES
//*		pF_111() 			// 4 le_point s  			( box + pers )
//*		pF_112( 0 ) 		// pL2					( box + pers, de 0  4 )
//		pF_113( 4 ) 		// pS22					( box + pers, de 0  6 )
//*		pF_114( 6 ) 		// pV222				( no box + pers, de 0  6 )
//*		pF_115() 			// pH2222				( box + pers )
// 12 : DIAGONALISATION
//*		pF_121( 0 ) 		// pS22 et pL3			( box + pers, de 0  4 )
//*		pF_122( 4 ) 		// pS23 et pL4			( box + pers, de 0  4 )
//*		pF_123() 			// pV222, pS23 et pL4	( no box + pers )
//*		pF_124( 4 ) 		// pS33 et pL5			( box + pers, de 0  4 )
// 13 : GENERALISATION, LES pFORMES
//*		pF_130() 			// pV333, pS35 et pL7	( no box + pers )
// 2 : OPERATIONS, PROPRIETES
// 21 : OPERATIONS FONDAMENTALES
// 211 : SUBDIVISION
// 212 : ELEVATION DU DEGRE
//		pF_212()			// ondulations sur un arc de cercle
// 213 : REPARAMETRISATION
//*		pF_2131() 			// pL4 reparamtrise	( box + pers )
//*		pF_2132() 			// pS35 reparamtrise	( box + pers )
//*		pF_214( ) 			// pFgetSubForm, pFgetPoint, pFgetPijk 	( box + pers )
// 22 : IMMERSIONS
// 221 : INTERPOLATION
//*		pF_2211() 			// pL5 interpolante				( box + pers )
//		pF_2212() 			// pS35 interpolante			( no box + pers )
// 222 : DIAGONALISATION
// 		pF_222()			//  construire 
// 223 : pFORMES IMMERGEES
//*		pF_2235() 			// pL3 immerge dans une PS33	( box + pers )
//*		pF_2236() 			// pL4 immerge dans une PS33	( box + pers )
//		pF_2237()			// cf tore immerg dans un cube V223
// 23 : INTERFACE
// 231 : TRANSFORMATIONS
//*		pF_2311()			// pFrotate sur une pL4			( no box + pers )
//*		pF_2312()			// pFtranslate sur une pL4		( no box + pers )
//		pF_2313()			// pFscale sur une pL4			( no box + pers )
// 232 : REPRESENTATION
// 3 : COMPOSITIONS
// 31 : FORMES RATIONNELLES
// 311 : CONIQUES
//*		pF_3111()			// les 4 coniques comme projections de pL3 	( no box + pers )
//*		pF_31121()			// pL3, pL4 et pL5 -> arcs de cercle 		( no box + AXO 4/8 )
//*		pF_31122( 3 )		// pL3, pL4 et pL5, projections	 	( no box + OZ 4/8, de 1  3 ) 
//*		pF_3113()			// 3  approches du cercle complet	 ( no box + AXO 3/8 )
//*		pF_3114( 0.5 )		// cercle immerg dans une pS33		( box + pers, de 0.0  k )
// 312 : CYLINDRE, TORE ET SPHERE
//		pF_312()			// le cylindre, le tore et la sphre	( no box + pers )
// 313 : LIGNES DANS LE TORE
//*		pF_3131( 9 )		// diagonales // immerges dans un tore	( no box + pers )
//*		pF_3132( 16 )		// faisceau de droites immerges dans un tore 	( no box + pers )
//		pF_3133( 16 )		// cercles concentriques immergs dans un tore 	( no box + pers )
//		pF_3134( 8, 1.5 )	// cercle et ses rayons (R<2) dans un tore 	( no box + pers )
// 32 : FORMES COMPOSEES
// 321 : MAILLAGES
// 		pF_3211()			// un pV223 dform
// 322 : SURFACES PRODUITS, SURFACES DE REVOLUTION
//*		pF_3221()			// un vase 		( no box + pers 2/3 )
// 323 : SURFACES TUBULAIRES
//*		pF_3231()			// un tubage granit 
// 324 : SURFACES AFFINES
//		pF_3241()			// cf existant
// 325 : FORMES PARALLELES
//		pF_3251()			// cf existant
// 326 : SURFACES DEVELOPPEES
//		pF_3261()			// a voir plus tard
// 33 : COMBINAISONS LINEAIRES SPECIALES
// 331 : FORMES SYMETRIQUES
//		pF_3311()			// cf existant
// 332 : SURFACES DE COONS
//*		pF_3321()			// surface minimale periodique COONS 	( no box + AXO 3/8 )
//*		pF_3322()			// coquillage COONS						( no box + AXO 7/8 )
//*		pF_3323(4)			// rideau COONS				( no box + PERS 5/6, k=1,2,3,4,... )								
// 34 : CONCATENATIONS, SPLINES
// 341 : SPLINES NON INTERPOLANTES
//		pF_3411()			// cf existant
// 342 : SPLINES INTERPOLANTES
//*		pF_3421( 4 )		// spline interpolante quadrique  (no box + AXO 7/8, k=1,2,3,4,...)
// 343 : LES NURBS
//		pF_3431()		// le cercle NURBS  (no box + AXO 7/8)
// 35 : OPERATEURS DE DEFORMATION
//		pF_351()		// tore immerg dans un cube pV223, cf existant
// 36 : GEOMETRIE DANS LES pFORMES
// 37 : AUTRES OPERATEURS SUR LES pFORMES
// 	macros STRAIGHT AWAY, cf pFbook.inc



