// fichier pFlibs.inc
// sous licence GNU open source
// http://marty.alain.free.fr
// version du 28/12/2003

#macro taille( _f ) // retourne la taille d'un tableau
    dimension_size( _f,1 )
#end
/*
    AFFICHAGE DES COMPOSANTES D'UN VECTEUR
*/
#macro affiche_vect( vvv )
    #debug "\n vecteur: < "
    #local n = taille( vvv );
    #local i=0; #while (i< n)
        #debug concat( str( vvv[i], 4,4 ), "," )
    #local i=i+1; #end
    #debug " >  \n"
#end
/*
    AFFICHAGE DES TERMES D'UNE MATRICE
*/
#macro affiche_mat( mat )    // 
    #debug "\n matrice:\n "
    #local n1= dimension_size( mat, 1 );
    #local n2= dimension_size( mat, 2 );
    #local i=0; #while (i< n1)        // pour chaque ligne i
        #debug concat( "ligne ", str(i,0,0), ": " )
        #local j=0; #while (j< n2)    // pour chaque colonne j
            #debug concat( str( mat[i][j],4,4 ), ", " )
        #local j=j+1; #end
        #debug "\n"
    #local i=i+1; #end
    #debug "\n"
#end
/*
    INVERSION D'UNE MATRICE CARREE 
    PAR LA METHODE DE GAUSS_JORDAN
    test:
    #local mat = array[3][3] { {3,2,1}, {1,3,2}, {2,4,3} }
    affiche_mat( mat )
    #local tam = inverse_mat( mat )
    affiche_mat( tam )
    stop
*/
#macro inverse_mat( ma )
    #local N = taille(ma);
    // creation d'une matrice [N][2*N]
    #local mat = array[N][2*N]
    #local I=0; #while (I< N)
        #local J=0; #while (J< N)
            #local mat[I][J] = ma[I][J];
        #local J=J+1; #end
    #local I=I+1; #end
    #local K=0; #while (K< N)
        #local I=0; #while (I< N)
            #if (K=I)    
                #local mat[I][N+K] = 1;    
            #else
                #local mat[I][N+K] = 0;    
            #end
        #local I=I+1; #end
    #local K=K+1; #end
    // start:
    #local EPS  = 0.0000001;
    #local singularite = false;
    #local DetA = 1;
    #local K = 0;    #while ( (K< N) & (!singularite) )
    // recherche de l'indice L du pivot maximum
        #local L=K;
        #local I=K; #while (I< N)
            #if ( abs(mat[I][K])  >   abs(mat[L][K]) )
                #local L=I;    
            #end
        #local I=I+1; #end
        #if ( abs(mat[L][K]) <= EPS )            
            #local singularite = true;    
        #else
            #if (L!=K)
                #local I=K; #while (I< 2*N)
                    #local mmm = mat[K][I];
                    #local mat[K][I] = mat[L][I];
                    #local mat[L][I] = mmm;
                #local I=I+1; #end
                #local DetA = -DetA;
            #end
        #end    
        #local DetA = DetA*mat[K][K];
    // elimination de xk
        #if (!singularite)
            #local J=K+1; #while (J< 2*N)
            #local mat[K][J] = mat[K][J]/mat[K][K];
            #local J=J+1; #end
            #local mat[K][K] = 1;
            #local I=0; #while (I< N)
                #if (I!=K)
                    #local J=K+1; #while (J< 2*N)
                    #local mat[I][J] = mat[I][J] -
                         (mat[I][K]*mat[K][J]);
                    #local J=J+1; #end
                    #local mat[I][K] = 0;
                #end
            #local I=I+1; #end
        #end
    #local K=K+1; #end
    #local tam = array[N][N]
    #local I=0; #while (I< N)
        #local J=0; #while (J< N)
            #local tam[I][J] = mat[I][J+N];
        #local J=J+1; #end
    #local I=I+1; #end
    tam
#end
#macro produit_mat( mat, vect )
    #local n= dimension_size( mat, 1 );
    #local tcev = array[n]
    #local i=0; #while (i< n)
        #local dd = 0;
        #local j=0; #while (j< n)
            #local dd = dd + mat[i][j]*vect[j];
        #local j=j+1; #end
        #local tcev[i] = dd;
    #local i=i+1; #end
    tcev
#end
/* ----------- EXPORT ET IMPORT DE FICHIERS FORMES --------- */
/*
    conserve une forme calcule sous forme texte
    utile dans le cas d'animations ou ventuellement
    pour transmettre des informations  d'autres programmes
*/
/*
     ECRITURE D,UNE COURBE DANS UN FICHIER:
    input:     la courbe et le nom du fichier
    output:    le fichier
    nota:    attention a ne pas ecraser un fichier de meme nom
        il n'y a pas de controle...
    appel:        #local courb = creer_une_courbe(x,x,...)
            ecrire_courbe( courb, "fichier.txt" )
*/
#macro pLwrite( f, fichier )
    #fopen myfile fichier write
    #local umax = taille(f);
    #write( myfile, "\"Une pCourbe\",\n" )
    #write( myfile, umax, ",\n" )
    #local i=0; #while (i< umax)
        #write( myfile, f[i], ",\n" )
    #local i=i+1; #end
    #fclose myfile
#end
/*
     LECTURE D,UNE COURBE DEPUIS UN FICHIER:
    input:         le nom du fichier
    output:        la courbe
    nota:    
    appel:         #local courb = lire_courbe( "fichier.txt" )
*/
#macro pLread( fichier )
    #fopen myfile fichier read
    #read( myfile, titre )
    #read( myfile, umax )
    #local ff = array[umax]
    #local i=0; #while (i< umax)
        #ifdef (ddd) #undef ddd #end    // peut etre a revoir
        #read( myfile, ddd )
        #local ff[i] = ddd;
    #local i=i+1; #end
    #fclose myfile
    /*return*/ ff
#end
/*
     ECRITURE D,UNE SURFACE DANS UN FICHIER:
    input:     la surface et le nom du fichier
    output:    le fichier
    nota:    attention a ne pas ecraser un fichier de meme nom
    appel:        #local surf = creer_une_surface(x,x,...)
                ecrire_surface( surf, "fichier.txt" )
*/
#macro pSwrite( f, fichier )
    #fopen myfile fichier write
    #local umax = taille(f);
    #local vmax = taille(f[0]);
    #write( myfile, "\"Une pSurface\",\n" )
    #write( myfile, umax, ",\n" )
    #write( myfile, vmax, ",\n" )
    #local i=0; #while (i< umax)
        #local j=0; #while (j< vmax)
            #write( myfile, f[i][j], ",\n" )
        #local j=j+1; #end        
    #local i=i+1; #end
    #fclose myfile
#end
/*
     LECTURE D,UNE SURFACE DEPUIS UN FICHIER:
    input:         le nom du fichier
    output:        la surface
    nota:    
    appel:         #local surf = lire_surface( "fichier.txt" )
*/
#macro pSread( fichier )
    #fopen myfile fichier read
    #read( myfile, titre )
    #read( myfile, umax )
    #read( myfile, vmax )
    #local ff = array[umax]
    #local pp = array[vmax]
    #local i=0; #while (i< umax)
        #local j=0; #while (j< vmax)
            #ifdef (ddd) #undef ddd #end
            #read( myfile, ddd )
            #local pp[j] = ddd;
        #local j=j+1; #end    
        #local ff[i] = pp    
    #local i=i+1; #end
    #fclose myfile
    /*return*/ ff
#end
/*----------- MACROS GENERALES DANS R4 ------------*/
/*
    TRANSFORMATION GENERALE AFFINE:
        pp.x        00 01 02 03        p.x
        pp.y   =    10 11 12 13    *   p.y
        pp.z        20 21 22 23        p.z
        pp.t        30 31 32 33        p.t
*/
#macro pFtransform( mat, p )
< mat[0][0]*p.x + mat[0][1]*p.y + mat[0][2]*p.z + mat[0][3]*p.t,
  mat[1][0]*p.x + mat[1][1]*p.y + mat[1][2]*p.z + mat[1][3]*p.t,
  mat[2][0]*p.x + mat[2][1]*p.y + mat[2][2]*p.z + mat[2][3]*p.t,
  mat[3][0]*p.x + mat[3][1]*p.y + mat[3][2]*p.z + mat[3][3]*p.t
  >  
#end
#macro pFtranslate( dim, f, dt )    // translation d'une pForme
    #if (dim=0)
        #local tt = f.t;    //   partir d'une translation
                    // dans R3 < dt.x,dt.y,dt.z >  
        #local pp = < f.x/tt, f.y/tt, f.z/tt >   + dt;
        #local f = < pp.x*tt, pp.y*tt, pp.z*tt, tt >  ;
    #else
        #local n = taille( f );
        #local i=0; #while (i< n)
            pFtranslate( dim-1, f[i], dt )
        #local i=i+1; #end
    #end
#end
#macro pFrotate( dim, f, dr )    // rotation d'une pForme
    #if (dim=0)
        #local tt = f.t;    //   partir d'une rotation
                    // dans R3 < dr.x,dt.y,dt.z >  
        #local pp = < f.x/tt, f.y/tt, f.z/tt >  ;
        #local rad = pi/180;
        #if (dr.x != 0)
            #local pp = < 
            pp.x, 
            cos(rad*dr.x)*pp.y - sin(rad*dr.x)*pp.z,
            sin(rad*dr.x)*pp.y + cos(rad*dr.x)*pp.z >  ;
        #end
        #if (dr.y != 0)
            #local pp = <    
            cos(rad*dr.y)*pp.x -sin(rad*dr.y)*pp.z,
            pp.y,
            sin(rad*dr.y)*pp.x + cos(rad*dr.y)*pp.z >  ;
        #end
        #if (dr.z != 0)
            #local pp = <    
            cos(rad*dr.z)*pp.x - sin(rad*dr.z)*pp.y,
            sin(rad*dr.z)*pp.x + cos(rad*dr.z)*pp.y,
            pp.z >  ;
        #end
        #local f = < pp.x*tt, pp.y*tt, pp.z*tt, tt >  ;
    #else
        #local n = taille( f );
        #local i=0; #while (i< n)
            pFrotate( dim-1, f[i], dr )
        #local i=i+1; #end
    #end
#end
#macro pFscale( dim, f, ds )    // homothetie d'une pForme
    #if (dim=0)
        #local tt = f.t;    //   partir d'une homothetie
                    // dans R3 < ds.x,ds.y,ds.z >  
        #local pp = < f.x/tt*ds.x, f.y/tt*ds.y, f.z/tt*ds.z >  ;
        #local f = < pp.x*tt, pp.y*tt, pp.z*tt, tt >  ;
    #else
        #local n = taille( f );
        #local i=0; #while (i< n)
            pFscale( dim-1, f[i], ds )
        #local i=i+1; #end
    #end
#end
/*
    MACROS INTERNES
*/
#macro _interpol( dim, f0, f1, uu )    // interpole deux formes
    #if (dim=0)
        (1-uu)*f0 + uu*f1;
    #else
        #local nb = taille( f0 );
        #local fm = array[nb]
        #local i=0; #while (i< nb)
        #local fm[i] = _interpol( dim-1, f0[i], f1[i], uu )
        #local i=i+1; #end
        fm
    #end
#end
#macro _shift( dim, n, sens, uu )    
    // calcule la sous_forme droite ou gauche
    #if (n >  0)
        #local i=0; #while (i< n)
            #if (sens)            // droite
    #declare _d[i] = _interpol( dim-1, _d[i], _d[i+1], uu )
            #else                // gauche
                #local nb = taille( _g );
                #local k = nb-1-i;
    #declare _g[k] = _interpol( dim-1, _g[k], _g[k-1], uu )
            #end
        #local i=i+1; #end
        _shift( dim, n-1, sens, uu )
    #end
#end
#macro _stretch( dim, f, p0, p1 )    // cale f entre p0.x et p1.x
    #local _g = f
    _shift( dim, taille(f)-1, false, 1-p1.x ) // travail sur g
    #local _d = _g
    _shift( dim, taille(f)-1, true, p0.x/p1.x )    // travail sur d
    _d                                        // mmes dims que f
#end
#macro _sous_subdi( dim, p, r )    
    // charge out et incrmente index
    #if (dim=0)
        #declare out[index] = p;
    #else
        #local pp = pFsubdivision( dim,p,< r.y, r.z, r.t, 0 >   )
        #declare out[index] = pp
    #end
    #declare index=index+1;
#end
#macro _subdi( dim, f, r, uu )    
    // corps rcursif de subdivision()
    #if (r.x=0)
        #local i=0; #while (i< nb_in-1)
            _sous_subdi( dim-1, f[i], r )
        #local i=i+1; #end
    #else
        #local _g = f
        #local _d = f    
        _shift(dim, nb_in-1,true,uu)
        _shift(dim, nb_in-1,false,uu)
        _subdi( dim, _g, < r.x-1, r.y, r.z, r.t >  , uu )
        _subdi( dim, _d, < r.x-1, r.y, r.z, r.t >  , uu )
    #end
#end

// en attendant de reecrire proprement la macro pFstrecth
// qui inverse les x et les y, penser a utiliser celle-ci :
#macro flipxy( p )
	(<p.y,p.x,p.z,p.t>)
#end


/*
    3 MACROS FONDAMENTALES
*/
 #macro pFsubdivision( dim, in, r )    
    // retourne la forme subdivisee
    #local nb_in = taille(in);        // rcursivement au 1/2
    #local nb_out = (nb_in-1)*pow(2, r.x)+1;    //
    #local out = array[nb_out]
    #local index = 0;
    _subdi(dim, in, r, 1/2)                            // _subdi(dim, in, r, 1/3) sierpinsky
    _sous_subdi(dim-1, in[nb_in-1], r)
    out
#end
#macro pFstretch( dim, f, p0, p1 )        
    #if (dim=1)
        _stretch( 1, f, p0, p1 )
    #else
        #local ff = _stretch( dim, f, p0, p1 )    
        // ff prend f recal entre p0.x et p1.x
        #local n = taille(ff);    // nb de sous_formes
        #local i=0; #while (i< n) // pour chaque sous_forme:
 //         #local ff[i] = pFstretch( dim-1, ff[i], < p0.y,p0.z,0,1 >  , < p1.y,p1.z0,1 >   )
            #local ff[i] = pFstretch( dim-1, ff[i], < p0.y,p0.z,p0.t,p0.t >  , < p1.y,p1.z,p1.t,p1.t >   )
        #local i=i+1; #end
        ff    // retourne ff recale 
    #end
#end
#macro pFgetSubForm( dim, f, uu )     // retourne la sous_forme
    #local _d = f    // generatrice en uu (uu est un REEL !!)
    _shift(dim, taille(f)-1, true, uu)
    _d[0]    // tableau unidim
#end

// inverse lignes et colonnes d'une surface, envisager pFtranspose( forme )
#macro transpose_surface( surf )
	#local m = taille(surf);
	#local n = taille(surf[0]);
	#local transp = array[n]
	#local i=0; #while (i<n)
		#local ttt = array[m]
		#local j=0; #while (j<m)
			#local ttt[j] = surf[j][i];
		#local j=j+1; #end
		#local transp[i] = ttt	
	#local i=i+1; #end
	transp
#end
/*
    IMMERSION
1) get_point() retourne les coordonnes globales d'un point dfini
   en coordonnes locales (p) dans la pForme f
2) immersion() transforme une ipForme dfinie en coordonnes locales dans une pForme,
   en un tableau de points dfinis en coordonnes globales. 
   Ce tableau ne dfinit pas une pForme (une post-subdivision n'est pas possible)
3) voir plus loin les macros interpolation plus gnrales et retournant
   les points de contrle dans le cas de pCourbes dans une pSurface
*/
#macro pFgetPoint( dim, f, p )
    #local qt = p.t;
    #local q = < p.x/qt, p.y/qt, p.z/qt,1 >  ;
    #switch (dim)
        #case (1)
            #local pp = pFgetSubForm( 1, f, q.x );
        #break
        #case (2)
            #local ff = pFgetSubForm( 2, f, q.y )
            #local pp = pFgetSubForm( 1, ff, q.x );
        #break
        #case (3)
            #local gg = pFgetSubForm( 3, f, q.z )
            #local ff = pFgetSubForm( 2, gg, q.y )
            #local pp = pFgetSubForm( 1, ff, q.x );
        #break
        #case (4)
            #local hh = pFgetSubForm( 4, f, q.t )
            #local gg = pFgetSubForm( 3, hh, q.z )
            #local ff = pFgetSubForm( 2, gg, q.y )
            #local pp = pFgetSubForm( 1, ff, q.x );
        #break
        #else    
            #debug "...nothing out there !!! "
    #end
    < pp.x*qt, pp.y*qt, pp.z*qt, pp.t*qt >  ;
#end
#macro pFimmersion( dim, f, idim, imf )        
    // ATTENTION: imf est modifie
    #if (idim=0)        // et n'est plus une pForme
        #local imf = pFgetPoint( dim, f, imf )
        // NO post-subdivision
    #else
        #local n = taille( imf );
        #local i=0; #while (i< n)
            pFimmersion( dim, f, idim-1, imf[i] )
        #local i=i+1; #end
    #end
#end

#macro pLlocal2global( loccurv, surf )
	#local globcurv = loccurv
	#local i=0; #while (i<taille(loccurv))
		#local globcurv[i] = pFgetPoint( 2, surf, loccurv[i] );
	#local i=i+1; #end
	globcurv
#end

#macro pSlocal2global( locsurf, surf )
	#local globsurf = locsurf
	#local i=0; #while (i<taille(locsurf))
	#local j=0; #while (j<taille(locsurf[0]))
		#local temp = locsurf[i][j];
	//	#local _temp = <temp.y, temp.x, temp.z, temp.t>;
	//	#local globsurf[i][j] = pFgetPoint( 2, surf, _temp );
		#local globsurf[i][j] = pFgetPoint( 2, surf, temp );
	#local j=j+1; #end
	#local i=i+1; #end
	globsurf
#end

/*
    DIAGONALISATION D'UNE FORME
*/
#macro _diag_N2( M, s0, s1 )    
    // diagonale d'une surface de type [N,2]
    #local pp = array[M+1]
    #local pp[0] = s0[0];
    #local pp[M] = s1[M-1];
    #local i=1;        #while (i< M)
        #local uu = i/M;
        #local pp[i] = (1-uu)*s0[i] + uu*s1[i-1];
    #local i=i+1;    #end
    pp
#end
#macro _diag_surf( surf )        
    // diagonale d'une surface de type [M,N]
    #local M = taille( surf[0] );
    #local N = taille( surf );
    #if (N >  2)
        #local ss = array[N-1]
        #local j=0;        #while (j< N-1)
        #local ss[j] = _diag_N2( M, surf[j], surf[j+1] )
        #local j=j+1;    #end
        _diag_surf( ss )
    #else
        _diag_N2( M, surf[0], surf[1] )
    #end
#end
#macro pFdiagonalisation( dim, f )    
    // diagonale d'une pForme quelconque
    #if (dim=2)
        _diag_surf( f )
    #else
        #local M = taille( f );    // nb de sous-formes
        #local ddd = array[M]
        #local i=0;    #while (i< M)
            #local ddd[i] = pFdiagonalisation(dim-1,f[i])
        #local i=i+1;    #end
        ddd
    #end
#end
/*
    ELEVATION DU DEGRE D'UNE FORME
*/
#macro pLup( f, dd ) // en attendant une version up_forme qq...
    #local ff = f
    #local i=0; #while (i< dd)
        #local N = taille(ff);
        #local fff = array[N+1]
        #local fff[0] = ff[0];
        #local fff[N] = ff[N-1];
        #local j=1; #while (j< N)
            #local fff[j] = j/N*ff[j-1] + (1-j/N)*ff[j];
        #local j=j+1;    #end
        #local ff = fff
    #local i=i+1;    #end
    ff
#end
#macro pSup( f, dd ) // en attendant une version up_forme qq...
    #local M = taille( f );    // nb de courbes
    #local i=0; #while (i< M)    // pour chaque courbe:
        #local f[i] = pLup( f[i], dd.u )    // lever degr
    #local i=i+1; #end
    #local N = taille( f[0] );    // nb de points d'une courbe
    #local ff = array[N]        // cration d'une surface ortho
    #local i=0; #while (i< N)    // pour chaque point:
        #local M = taille( f );    // nb de courbes
        #local fff = array[M]    // cration d'une courbe ortho 
        #local j=0; #while (j< M)
            #local fff[j] = f[j][i];
        #local j=j+1; #end
        #local ff[i] = pLup( fff, dd.v )    // lever degr
    #local i=i+1; #end
    ff
#end
/*
    AFFICHAGE D'UNE FORME DANS LE CAS GENERAL
        cas des points, courbes, surfaces et volumes 
        trait plus loin sous diffrentes formes
*/
#macro pFdraw( dim, f, rayon )                
    // dessine les points de la pForme dans R3
    #if (dim=0)
        sphere { < f.x/f.t, f.y/f.t, f.z/f.t  >  , rayon } 
    #else
        #local n = taille( f );
        #local i=0; #while (i< n)
            pFdraw( dim-1, f[i], rayon )
        #local i=i+1; #end
    #end
#end
/*------------- COURBES INTERPOLANTES ET 
            COURBES IMMERGEES DANS UNE SURFACE ------------*/
//    MATRICE DE POINTS UNIFORMEMENT DISTRIBUES SUR UNE pCOURBE
/*
	c.pascal	1			3				3				1		
	valeurs :	(1-t)^3		(1-t)^2*t			(1-t)*t^2			t^3		
	t=0/3		1			0				0				0
	t=1/3		(2/3)^3		(2/3)^2*(1/3)		(2/3)*(1/3)^2		(1/3)^3
	t=2/3		(1/3)^3		(1/3)^2*(2/3)		(1/3)*(2/3)^2		(2/3)^3
	t=3/3		0			0				0				1
*/
#macro calcul_mat( n )					// matrice de n points 
	#macro fact( n )					// macro interne factorielle
	    #if (n=0) 1;
	    #else n*fact(n-1) #end    
	#end

	#macro pw(a,b)						// macro interne puissance
		#if (b<=0) 1;					// equiv pow(a+EPS, b );
		#else a*pw(a,b-1) #end			// plus rapide
	#end											

	#local mat = array[n+1][n+1]			// sur une pLn
	#local fn = fact( n )
	#local j=0; #while (j<=n)
		#local fnj = fact( n-j )
		#local fj  = fact( j )
		#local coeff = fn/(fnj*fj);
		#local i=0; #while (i<=n)
			#local _ttt = pw(1-i/n,n-j)
			#local ttt  = pw(i/n,j)
			#local mat[i][j] = coeff*_ttt*ttt;
		#local i=i+1; #end
	#local j=j+1; #end
	mat
#end

#macro ctrliCurvInSurf( surf, curv )    
    // nb de points de controle
    #local nb1 = taille( surf );        // de la courbe de R4
    #local nb2 = taille( surf[0] );// correspondant a la courbe
    #local nb = taille( curv );    // immergee dans une surface
    ((nb1+nb2-2)*(nb-1)+1)
#end
/*
    pCOURBE et pSURFACE INTERPOLANTES
    en attente d'une formule generale pour les pFormes
*/
#macro pLinterpolante( curv )
    #local n = taille( curv );
    #local vx = array[n]
    #local vy = array[n]
    #local vz = array[n]
    #local vt = array[n]
    #local i=0; #while (i< n)
        #local vx[i] = curv[i].x;
        #local vy[i] = curv[i].y;
        #local vz[i] = curv[i].z;
        #local vt[i] = curv[i].t;
    #local i=i+1; #end
    #local mat = calcul_mat( n-1 )			//affiche_mat( mat )
    #local tam = inverse_mat( mat )			//affiche_mat( tam )
    #local _vx = produit_mat( tam, vx )    
    #local _vy = produit_mat( tam, vy )    
    #local _vz = produit_mat( tam, vz )    
    #local _vt = produit_mat( tam, vt )
    #local icurv = array[n]
    #local i=0; #while (i< n)
        #local icurv[i] = < _vx[i], _vy[i], _vz[i], _vt[i]  >  ;
    #local i=i+1; #end
    icurv
#end
#macro pSinterpolante( surf )
    #local m = taille(surf);
    #local n = taille(surf[0]);
    #local ipLm = array[m]
    #local i=0; #while (i< m)
        #local ipLm[i] = pLinterpolante( surf[i] )
    #local i=i+1; #end
    #local temp = array[m] 
    #local isurf = array[n]
    #local i = 0; #while (i< n)        
        #local j=0; #while (j< m)
            #local temp[j] = ipLm[j][i];
        #local j=j+1; #end
        #local isurf[i] = pLinterpolante( temp )
    #local i=i+1; #end
    isurf
#end

/*
	verification de pLinterpolante sur une courbe rationnelle
	tester : pLinterpolante_verif( 30 )
*/
#macro pLinterpolante_verif( k )
	// un arc de cercle (pL3) :
	#local arc = quart_cercle_3( 0.5, 1 )
	// 3 points repartis uniformement sur l'arc :
	#local _arc = array[3]
	#local i=0; #while (i<3)
		#local _arc[i] = pFgetPoint( 1, arc, <i/2,0,0,1> )
	#local i=i+1; #end
	// calcul de la courbe interpolante
	#local _arc = pLinterpolante( _arc )
	// etirement des deux courbes
	#local arc = pFstretch( 1, arc, <0-k,0,0,1>, <1+k,0,0,1> )
	#local _arc = pFstretch( 1, _arc, <0-k,0,0,1>, <1+k,0,0,1> )
	draw( 1, arc, finesse(6)+courbe(0.01)+ma_couleur(<1,0,0>))
	draw( 1, _arc, finesse(6)+courbe(0.02)+ma_couleur(<1,1,0,0.5>))
	// les deux courbes concordent
#end

/*
	verification de pSinterpolante sur une surface rationnelle
*/
#macro pSinterpolante_verif_3( k )	// pSinterpolante_verif_3( 5 )
	// une portion de tore (pS33) :
	#local tore = creer_tore( 0.5, 0.2 )
	// 9 points repartis uniformement sur le tore :
	#local _tore = array[3]
	#local i=0; #while (i<3)
		#local p = array[3]
		#local j=0; #while (j<3)
			#local p[j] = pFgetPoint( 2, tore, <j/2,i/2,0,1> )
		#local j=j+1; #end
		#local _tore[i] = p
	#local i=i+1; #end
	// calcul de la surface interpolante
	#local _tore = pSinterpolante( _tore )
	// etirement des deux surfaces
	#local tore = pFstretch( 2, tore, <0-k,0-k,0,1>, <1+k,1+k,0,1> )
	#local _tore = pFstretch( 2, _tore, <0-k,0-k,0,1>, <1+k,1+k,0,1> )
	draw( 2, tore, finesse(<4,4>)+le_point(0.01)+ma_couleur(<1,0,0>))
	draw( 2, _tore, finesse(<4,4>)+le_point(0.03)+ma_couleur(<1,1,0,0.8>))
	// les deux surfaces concordent
#end
#macro pSinterpolante_verif( h )		// pSinterpolante_verif( sqrt(2)/2*0.8 )
	// une portion de tore (pS55) :
	#local c2 = demi_cercle_5( 1 )				// chemin dans xOz
	#local c1 = demi_cercle_5( 0.25 ) 			// section dans xOy
	pFtranslate( 1, c1, <0.5,0,0> )
	#local tore = cross( c1, c2 )
	// 25 points repartis uniformement sur le tore :
	#local N=5;
	#local _tore = array[N]
	#local i=0; #while (i<N)
		#local p = array[N]
		#local j=0; #while (j<N)
			#local p[j] = pFgetPoint( 2, tore, <j/(N-1),i/(N-1),0,1> )
		#local j=j+1; #end
		#local _tore[i] = p
	#local i=i+1; #end
	// calcul de la surface interpolante
	#local _tore = pSinterpolante( _tore )
	// etirement des deux surfaces
	#local tore  = pFstretch( 2, tore, <-h,-h,0,1>, <1+h,1+h,0,1> )
	#local _tore = pFstretch( 2, _tore, <-h,-h,0,1>, <1+h,1+h,0,1> )
	pFscale( 2, tore, <1,-1,1> )
	pFscale( 2, _tore, <1,-1,1> )
	draw( 2, tore, finesse(<3,3>)+le_point(0.01)+ma_couleur(<1,0,0>))
	draw( 2, _tore, finesse(<3,3>)+le_point(0.03)+ma_couleur(<1,1,0,0.8>))
	// les deux surfaces concordent
#end


//    pCOURBE IMMERGEE DANS UNE pSURFACE  
#macro courbe_in_surface( ipCourbe, pSurface )						// ipCourbe est definie dans la pSurface
	#local N = ctrliCurvInSurf( pSurface, ipCourbe );
	#local P = array[N]
	#local i=0; #while (i<N)										// distribution uniforme de points
		#local p = pFgetPoint( 1, ipCourbe, <i/(N-1),0,0,1> )		// p est sur la ipCourbe dans la pSurface
		#local P[i] = pFgetPoint(2, pSurface, p )					// P[i] est dans l'espace
	#local i=i+1; #end												// 
	pLinterpolante( P )												// retour de la pCourbe dans l'espace
#end

//		IMMERSION version quasi generale
// retourne la pForme/E equivalente a ipForme/pForme

#macro _pFimmersion( idim, ipF, dim, pF )
	#switch (idim)
		#case (1)		// une ipCourbe dans une pForme
				#switch (dim)
					#case (2)	// une ipCourbe dans une pSurface
							#local nb1 = taille( pF );
    						#local nb2 = taille( pF[0] );
    						#local nb = taille( ipF );
							#local N = ((nb1+nb2-2)*(nb-1)+1);
							// calcul d'une distribution de N points sur la ipCourbe :
							#local P = array[N]
							#local i=0; #while (i<N)
								#local p = pFgetPoint( 1, ipF, <i/(N-1),0,0,1> )
								#local P[i] = pFgetPoint(2, pF, p )
							#local i=i+1; #end				
							pLinterpolante( P )
					#break
					#case (3)	// une pCourbe dans un pVolume
							#local nb1 = taille( pF );
    						#local nb2 = taille( pF[0] );
    						#local nb3 = taille( pF[0][0] );
    						#local nb = taille( ipF );
							#local N = ((nb1+nb2+nb3-3)*(nb-1)+1);
							// calcul d'une distribution de N points sur la ipCourbe :
							#local P = array[N]
							#local i=0; #while (i<N)
								#local p = pFgetPoint( 1, ipF, <i/(N-1),0,0,1> )
								#local P[i] = pFgetPoint(3, pF, p )
							#local i=i+1; #end				
							pLinterpolante( P )
					#break
				#end
		#break
		#case (2)		// une ipSurface dans une pForme
				#switch (dim)
					#case (2)	// une ipSurface dans une pSurface
						#local m  = taille( pF ) ;								
						#local n  = taille( pF[0] ) ;								
						#local im = taille( ipF ) ;								
						#local in = taille( ipF[0] ) ;								
						#local M = (m+n-2)*(im-1)+1;		
						#local N = (m+n-2)*(in-1)+1;		
						// calcul d'une distribution [M,N] de points sur la ipSurface :
						#local ipS = array[M]
						#local tt = array[N]
						#local i=0; #while (i<M)
							#local j=0; #while (j<N)	
								#local ttt = pFgetPoint( 2, ipF, <i/(M-1),j/(N-1),0,1> )
								#local tt[j] = pFgetPoint( 2, pF, ttt )
							#local j=j+1; #end
							#local ipS[i] = tt
						#local i=i+1; #end
						pSinterpolante( ipS )
					#break
				#end
		#break
	#end
#end

/* ----------- SPLINES INTERPOLANTES ----------------*/
// retourne des TABLEAUX de quadriques ou de cubiques
//    SPLINE INTERPOLANTE QUADRIQUE:    
#macro spline_interpolante_quadrique( b_1, b, cercle )
    #local n = taille( b );
    #local la_spline = array[n-1]
    #local q = array[3]
    #local q[1] = b_1;
    #local i=0; #while (i< n-1)
        #local q[0] = b[i];
        #local q[1] = 2*b[i] - b_1;
        #local q[2] = b[i+1];
        #local la_spline[i] = q
        #local b_1 = q[1];    
        #if (cercle) 
            #local la_spline[i][1] = la_spline[i][1]*sqrt(2)/2; 
        #end
    #local i=i+1; #end    
    la_spline
#end
//    SPLINE INTERPOLANTE CUBIQUE:    
#macro spline_interpolante_cubique( b_2, b_1, b )
    #local n = taille( b );
    #local la_spline = array[n-1]
    #local q = array[4]
    #local i=0; #while (i< n-1)
        #local q[0] = b[i];
        #local q[1] = 2*b[i] -b_1;
        #local q[2] =  4*b[i] -4*b_1 +b_2;
        #local q[3] = b[i+1];
        #local la_spline[i] = q    
        #local b_2 = q[1];
        #local b_1 = q[2];
    #local i=i+1; #end    
    la_spline
#end
/*----------- CREATION DE COURBES 
        ET SURFACES PRIMITIVES (dans R4) ------------*/
/*
     MAILLAGES BIDIM et TRIDM GAUCHES:
input:     le nombre de points de controle sur u,v,w et la ttt
output:    une pSmn ou un pVmnp orthogonaux a points de controle equirepartis
nota: 
appel:    
*/
#macro creer_ligne( n1, ttt )
    #local f = array[n1]
    #local i=0; #while (i< n1)
        #local p = < -0.5+ i/(n1-1), 0.0, 0.0, 1 >  ;
        #local f[i] = p * < ttt,ttt,ttt,1 >  ;
    #local i=i+1; #end
    f
#end
#macro creer_facette( n1, n2, ttt )
    #local f = array[n1]
    #local ff = array[n2]
    #local i=0; #while (i< n1)
        #local j=0; #while (j< n2)
        #local p = < -0.5+ i/(n1-1), -0.5 + j/(n2-1), 0.0, 1 >  ;
        #local ff[j] = p * < ttt,ttt,ttt,1 >  ;
        #local j=j+1; #end 
        #local f[i] = ff
    #local i=i+1; #end
    f
#end
#macro creer_cube( n1, n2, n3, ttt )
    #local f = array[n1]
    #local ff = array[n2]
    #local fff = array[n3]
    #local i=0; #while (i< n1)
        #local j=0; #while (j< n2)
            #local k=0; #while (k< n3)
    #local p = < -0.5+i/(n1-1), -0.5+j/(n2-1), -0.5+k/(n3-1), 1 >  ;
            #local fff[k] = p * < ttt,ttt,ttt,1 >  ;
            #local k=k+1; #end 
            #local ff[j] = fff
        #local j=j+1; #end 
        #local f[i] = ff
    #local i=i+1; #end
    f
#end
#macro pFmaillage( n, nn, ttt )
    #switch (n)
        #case (1)creer_ligne( nn, ttt )    #break;
        #case (2)creer_facette( nn.x, nn.y, ttt )    #break;
        #case (3)creer_cube(nn.x, nn.y, nn.z, ttt)    #break;
        #case (4)    #debug "... not yet !"
    #end
#end
#macro surface_aleatoire( surf, see, delta )
    #local ran = seed( see );
    #local m = taille(surf);
    #local n = taille(surf[0]);
    #local i = 0; #while (i< n)        
        #local j=0; #while (j< m)
            #local rrr = delta*rand( ran );
            pFtranslate( 0, surf[j][i], < 0,0,rrr >   )
        #local j=j+1; #end
    #local i=i+1; #end
    surf
#end
// version amelioree <x,y,z> et recadrage
#macro _surface_aleatoire( surf, see, delta )
	#local ran = seed( see );
	#local m = taille(surf);
	#local n = taille(surf[0]);
	#local vect = <0,0,0>;
	#local i = 0; #while (i< n)        
		#local j=0; #while (j< m)
			#local dv = <rand( ran )*delta.x, rand( ran )*delta.y, rand( ran )*delta.z> ;
			pFtranslate( 0, surf[j][i], dv )
			#local vect = vect + dv;	
		#local j=j+1; #end
	#local i=i+1; #end
	pFtranslate( 2, surf, vect/(-m*n) )	// recadrage moyen
	surf
#end

/*
     COURBES ARC DE CERCLE:
input:     le rayon du cercle
output:    une pL3 quart de cercle
        une pL4 demi-cercle
une pL5 demi_cercle, extensible au cercle complet par stretch
nota:          
*/
#macro quart_cercle_3( r, coeff )    
    // coeff: attirance du point mdian
    #local k = sqrt(2)/2;    //  - >   ellipse, cercle, hyperbole
    #local p0 = < r, 0, 0, 1 >  ;
    #local p1 = < r, r, 0, 1 >  *k*coeff;
    #local p2 = < 0, r, 0, 1 >  ;
    array[3]     { p0, p1, p2 }
#end
#macro demi_cercle_4( r )
    #local p0 = <  r, 0,  0, 1 >  ;
    #local p1 = <  r, 2*r,0, 1 >  /3;
    #local p2 = < -r, 2*r,0, 1 >  /3;
    #local p3 = < -r, 0,  0, 1 >  ;
    array[4]     { p0, p1, p2, p3 }
#end
#macro demi_cercle_5( r )
    #local k = sqrt(2)/2;
    #local p0 = <  r, 0,      0, 1 >  ;
    #local p1 = <  r, r,      0, 1 >  *k;
    #local p2 = <  0, 3/2*r,0, 1 >  *2/3;
    #local p3 = < -r, r,      0, 1 >  *k;
    #local p4 = < -r, 0,      0, 1 >  ;
    array[5]     { p0, p1, p2, p3, p4 }
#end
#macro arc_cercle( n, r )
    #switch(n)
        #case (3)    quart_cercle_3( r, 1 ) #break
        #case (4)    demi_cercle_4( r ) #break
        #case (5)    demi_cercle_5( r ) #break
    #end
#end
#macro creer_cylindre( R, H )
    #local k = sqrt(2)/2;
    #local temp = array[2] 
    #local temp[0] = array[3] 
        {   < R, 0, 0, 1 >,
            < R, R, 0, 1 >*k,
            < 0, R, 0, 1 >
        },
    #local temp[1] = array[3] 
        {   < R, 0, H, 1 >,
            < R, R, H, 1 >*k,
            < 0, R, H, 1 >
        } 
    temp
#end
#macro creer_tore( R1, R2 )
    #local k = sqrt(2)/2;
    #local R12 = R1+R2;
    #local R2 = abs(R2);
    #local temp = array[3]     
    #local temp[0] =   array[3] 
        {   < 0,   0, -R12, 1 >,
            < 0,  R2, -R12, 1 >*k,
            < 0,  R2,  -R1, 1 >
        }
    #local temp[1] =   array[3] 
        {   < R12,  0, -R12, 1 >*k,
            < R12, R2, -R12, 1 >*k*k,
            <  R1, R2, -R1,  1 >*k
        }
    #local temp[2] =   array[3] 
        {   < R12,  0,  0, 1 >,
            < R12, R2,  0, 1 >*k,
            <  R1, R2,  0, 1 >
        }
    temp
#end
 
/*
     SURFACE PRODUIT:
input:     deux pLn planes dans Oxy, profil et section
output:    une pSmn
nota:    cas particuliers: prismes et surfaces de rvolution
        profil gauche  etudier
*/
#macro cross( c1, c2 )
    #local nb1 = taille( c1 );    // courbes profil
    #local nb2 = taille( c2 );    // courbe section
    #local surf = array[nb1]    // surface produite
    #local i = 0; #while (i< nb1)    // pour chaque point du profil
        #local profil = c1[i];// un point du profil
        #local pp = array[nb2]
        #local j=0; #while (j< nb2)// pour chaque pt  section
            #local section = c2[j];// un pt de la section
        #local pp[j] = < 
            section.x*profil.x,    // base sur x
              section.t*profil.y,    // le long de l'axe y
              section.y*profil.x,    // base sur z
              section.t*profil.t  >  ;    
        #local j=j+1; #end
        #local surf[i] = pp
    #local i=i+1; #end
    surf
#end
/*
     SURFACE TUBULAIRE
input: une pLm chemin et une pLn section
    les valeurs de recusrion sur u et v (pre-subdivision)
output:        une pSmn (qui pourra etre subdivisee)
nota:         fonctionne avec les courbes rationnelles
*/
#macro pipe(che, sec, r1, r2)
    #local chemin  = pFsubdivision( 1, che, < r1,0,0,0 >   )
    #local section = pFsubdivision( 1, sec, < r2,0,0,0 >   )
    #local vmax = taille(chemin);
    #local umax = taille(section);
    #local tube = array[vmax]
    #local pp = array[umax]
        #local i = 0; #while (i< vmax)
            #local mat = pLgetFrenet( che, i/(vmax-1) )
            #local j = 0; #while (j< umax)
            #local pp[j] = pFtransform( mat, section[j] );
            #local j=j+1; #end
            #local tube[i] = pp
        #local i=i+1; #end
    tube
#end
/*
     SURFACE TUBULAIRE ONDULEE
    #local surf = waving_pipe( chemin,section,< 4, 3 >  ,< 0.5, 5 >   )
*/
#macro waving_pipe(che, sec, r, ondulation )
    #local chemin  = pFsubdivision( 1, che, < r.x,0,0,0 >   )
    #local section = pFsubdivision( 1, sec, < r.y,0,0,0 >   )
    #local vmax = taille(chemin);
    #local umax = taille(section);
    #local tube = array[vmax]
    #local pp = array[umax]
        #local i = 0; #while (i< vmax)
            #local uu = i/(vmax-1);
            #local mat = pLgetFrenet( che, uu )
#local coeff = 1 + ondulation.x *sin( 2*pi*uu * ondulation.y );
            #local temp = mat
            #local temp[0][0] = mat[0][0]* coeff;
            #local temp[1][1] = mat[1][1]* coeff;
            #local temp[2][2] = mat[2][2]* coeff;
            #local j = 0; #while (j< umax)
        #local pp[j] = pFtransform( temp, section[j] );
            #local j=j+1; #end
            #local tube[i] = pp
        #local i=i+1; #end
    tube
#end
/*
    SURFACES PARALLELES
    cre une surface situe  la distance dd d'une surface
    autres cas possibles avec modulation de dd
*/
#macro surface_parallele( surf, dd )
    #local m = taille( surf );
    #local n = taille( surf[0] );
    #local S = surf
    #local i = 0; #while (i< n)        
        #local j=0; #while (j< m)
        #local mat = pSgetPijk( surf, < j/(n-1),i/(m-1),0,1 >   )
        #local nn = < mat[0][0], mat[1][0], mat[2][0]  >  ;
            #local pp = S[j][i];
            #local pt = pp.t;
            #local qq = < pp.x/pp.t, pp.y/pp.t, pp.z/pp.t >  ;
            #local qq = qq + nn*dd;
        #local S[j][i] = < qq.x*pt,qq.y*pt,qq.z*pt, pt >  ;
        #local j=j+1; #end
    #local i=i+1; #end
    S
#end
/*
    SURFACES COMBINAISONS LINEAIRES
    exemples de surfaces rsultant d'une combinaison linaire d'autres surfaces ;
    la somme des coefficients doit tre gale  1.
    le cas le plus connu est celui des surfaces de Coons
*/
/*
    SURFACES SYMETRIQUES
    cre une surface symtrique par rapport  une autre surface
    cas particulier: symtrie plan
*/
#macro surface_symetrique( s1, s2 )    // surf = 2*s1 - s2
    #local M = taille( s1 );
    #local N = taille( s2[0] );
    #local surf = array[M]
    #local i=0; #while (i< M)
        #local pp = array[N]
        #local j=0; #while (j< N)
            #local pp[j] = 2*s1[i][j] - s2[i][j];
        #local j=j+1; #end
        #local surf[i] = pp
    #local i=i+1; #end
    surf
#end
/*
     SURFACE DE COONS:
input:     4 pLi deux a deux concourantes en quatre points
output:    une pSmn interpolant ces courbes
nota:     les 4 courbes peuvent tre de degrs diffrents
*/
#macro creer_coons( L1, L2, L3, L4 )
    // ajuster les degrs de L1 et L2, et de L3 et L4
    #local M = taille(L1);
    #local m = taille(L2);
    #if (M >  m)    #local L2 = pLup( L2, M-m )    #end
    #if (M< m)    #local L1 = pLup( L1, m-M )    #end
    #local N = taille(L3);
    #local n = taille(L4);
    #if (N >  n)    #local L4 = pLup( L4, N-n )    #end
    #if (N< n)    #local L3 = pLup( L3, n-N )    #end
    #local M = taille(L1);
    #local N = taille(L3);
    // construire s1 (pSM2) sur L1/L2 et lever  pSMN: 
    #local s1 = array[2] { L1, L2 }    
    #local s1 = pSup( s1, < 0,N-2 >   )
    // construire s2 (pS2N) sur L3/L4 et lever  pSMN: 
    #local s2 = array[N]
    #local i=0; #while (i< N)
        #local s2[i] = array[2] { L3[i], L4[i] }
    #local i=i+1; #end
    #local s2 = pSup( s2, < M-2,0 >   )
    // construire s3 (pS22) sur les 4 points d'angle 
    // et lever  pSMN: 
    #local L21 = array[2] { L1[0], L1[M-1] }
    #local L22 = array[2] { L2[0], L2[M-1] }
    #local s3 = array[2] { L21, L22 }
    #local s3 = pSup( s3, < M-2,N-2 >   )
    // construire coons = s1 + s2 - s3: 
    #local coons = array[M]
    #local i=0; #while (i< M)
        #local pp = array[N]
        #local j=0; #while (j< N)
            #local pp[j] = s1[i][j] + s2[i][j] - s3[i][j];
        #local j=j+1; #end
        #local coons[i] = pp
    #local i=i+1; #end
    coons
#end
//	GEODESIQUE
// macro calculant les points d'une geodesique
// input: surface, point depart, angle de tir, nombre de points
// output: tableau des points
#macro geodesique( surf, P, A, N, dt )
    #local EPS 	= 1.0e-4;
    #local U    = P.x;                     					// premier point en coords locales
    #local V    = P.y;
    #local du 	= EPS;
    #local dv 	= EPS;
    #local f   	= pFgetPoint( 2, surf, <U,V,0,1> )          // premier point en coords globales
    #local fdu 	= pFgetPoint( 2, surf, <U+du,V,0,1> )
    #local fdv 	= pFgetPoint( 2, surf, <U,V+dv,0,1> )
	 #local F 		= <f.x/f.t, f.y/f.t, f.z/f.t> ;
	 #local FDU 	= <fdu.x/fdu.t, fdu.y/fdu.t, fdu.z/fdu.t> ;
	 #local FDV 	= <fdv.x/fdv.t, fdv.y/fdv.t, fdv.z/fdv.t> ;			
    #local dfdu = (FDU - F) / du;                           // derivee premiere sur U
    #local dfdv = (FDV - F) / dv;                           // derivee premiere sur V
    #local coeff = vlength( dfdu ) / vlength( dfdv );
    #local tu = cos( A*pi/180 );                            // pente sur U 
    #local tv = sin( A*pi/180 ) * coeff;                    // pente sur V    
    #local tableau = array[N]
    #local i=0; #while (i<N)
        #local f     = pFgetPoint( 2, surf, <U,V,0,1> )     // point en coords globales
        #local fdu   = pFgetPoint( 2, surf, <U+du,V,0,1> ) 
        #local fdv   = pFgetPoint( 2, surf, <U,V+dv,0,1> )
        #local f2du  = pFgetPoint( 2, surf, <U+2*du,V,0,1> ) 
        #local f2dv  = pFgetPoint( 2, surf, <U,V+2*dv,0,1> )
        #local fdudv = pFgetPoint( 2, surf, <U+du,V+dv,0,1> )
			#local F = <f.x/f.t, f.y/f.t, f.z/f.t> ;
			#local FDU = <fdu.x/fdu.t, fdu.y/fdu.t, fdu.z/fdu.t> ;
			#local FDV = <fdv.x/fdv.t, fdv.y/fdv.t, fdv.z/fdv.t> ;			
			#local F2DU = <f2du.x/f2du.t, f2du.y/f2du.t, f2du.z/f2du.t> ;
			#local F2DV = <f2dv.x/f2dv.t, f2dv.y/f2dv.t, f2dv.z/f2dv.t> ;
			#local FDUDV = <fdudv.x/fdudv.t, fdudv.y/fdudv.t, fdudv.z/fdudv.t> ;
        #local dfdu   = (FDU - F) / du;                         // derivee premiere sur U
        #local dfdv   = (FDV - F) / dv;                         // derivee premiere sur V
        #local d2fduu = ((F2DU  - FDU)/du - (FDU-F)/du)/du;     // derivee seconde sur UU
        #local d2fduv = ((FDUDV - FDU)/du - (FDV-F)/du)/dv;     // derivee seconde sur VV
        #local d2fdvv = ((F2DV  - FDV)/dv - (FDV-F)/dv)/dv;     // derivee seconde sur UV
        #local U = U + tu*dt;                              		// point suivant en coords locales
        #local V = V + tv*dt;                              		// ...
        #local dudu = vdot(dfdu, dfdu);
        #local dudv = vdot(dfdu, dfdv);
        #local dvdv = vdot(dfdv, dfdv);
        #local cu = -(  tu*tu*vdot(dfdu, d2fduu) + 2*tu*tv*vdot(dfdu, d2fduv) + tv*tv*vdot(dfdu, d2fdvv) );
        #local cv = -(  tu*tu*vdot(dfdv, d2fduu) + 2*tu*tv*vdot(dfdv, d2fduv) + tv*tv*vdot(dfdv, d2fdvv) );    
        #local kk = dudu*dvdv - dudv*dudv;
        #if (abs(kk)<EPS) 
			//	#local kk = (kk>=0) ? EPS : EPS ;
				#if (kk>=0) 
					#local kk = EPS;
				#else 
					#local kk = -EPS; 
				#end				
			#end
        #local gu = (cu*dvdv - cv*dudv)/kk;                 // acceleration
        #local gv = (cv*dudu - cu*dudv)/kk;                 // ...
        #local tu = tu + gu*dt;                             // vitesse
        #local tv = tv + gv*dt;                             // ...
        #local tableau[i] = F;                              // chargement du point dans tableau
		#local i=i+1; #end
//	tableau
	#local geo = array[taille(tableau)]
	#local i=0; #while (i<taille(tableau))
		#local geo[i] = < tableau[i].x, tableau[i].y, tableau[i].z, 1 >;
	#local i=i+1; #end
	geo
#end

#macro tracer_normales_geodesique( geo, long, rayon )
	#local i=0; #while (i<taille(geo)-2)
		#local p0 = <geo[i+0].x, geo[i+0].y, geo[i+0].z >;
		#local p1 = <geo[i+1].x, geo[i+1].y, geo[i+1].z >;
		#local p2 = <geo[i+2].x, geo[i+2].y, geo[i+2].z >;
		#local tt = p1-p0;
		#local bb = vcross( p1-p0, p2-p0 );
		#local nn = vcross( bb, tt );
		#local nn = vnormalize( nn );
		cylinder { p0 - nn*long, p0 + nn*long, rayon pigment { color rgb <1,1,1> } } 				
	#local i=i+1; #end
#end

/*----------- MACROS COULEUR ET TEXTURE ------------*/
#declare GOLD         = 1;
#declare MIROIR         = 2;
#declare GRANIT         = 3;
#declare MARBRE         = 4;
#macro une_couleur( c )
    texture     
    {    pigment { color rgbt c }     
          finish  {     ambient 0.2 
                diffuse 0.6 
                specular 0.9 
                roughness 0.001 }    
                //reflection 0.4 }
    }
#end

#macro une_texture( choix )
    #switch (choix)
    #case (GOLD)
         texture 
        {	T_Gold_2C
/*        
        	pigment { color rgbt <1.00, 0.875, 0.575>   }
            finish 
             {	ambient 0.2 
                diffuse 0.7 
                specular 0.9 
                roughness 0.005
                //metallic 0.5 
                reflection 0.9 
               // brilliance 4
             } 
*/
        }
    #break
    #case (MIROIR)
        texture     
        {    pigment { color rgbt < 0,0,0 >   }
              finish {     ambient 0.2 
                    diffuse 0.7 
                    specular 0.9 
                    roughness 0.005 
                    reflection 0.9 }
          }
    #break
    #case (GRANIT)
        texture     
        {    pigment 
            {     granite
                color_map
                {
                [ 0.0    color rgbt < 1,1,1,0.0 >   ]
                [ 0.8    color rgbt < 0.2,0.1,0,0.0 >   ]
                [ 1.0    color rgbt < 1,1,0,0.0 >   ]
                }
                scale 1/16
            }
              finish {     ambient 0.2 
                    diffuse 0.6 
                    specular 0.9 
                    roughness 0.005 
                    reflection 0.0 }
          }
    #break
    #case (MARBRE)
        texture     
        {    pigment 
            {     marble
                color_map
                {
                [ 0.0    color rgbt < 0.9,0.9,0.9,0.7 >   ]
                [ 1.0    color rgbt < 0.2,0.2,0.2,0.0 >   ]
                }
                scale 1/32
                //turbulence 0.5
                rotate < 0,0,90 >  
            }
              finish {     ambient 0.2 
                    diffuse 0.7 
                    specular 0.9 
                    roughness 0.005 
                    reflection 0.0 }
          }
    #break
    #end
#end
/*----------- MACROS POUR LE DESSIN DES COURBES, 
            DES SURFACES ET DES VOLUMES ------------*/
//    PROJECTIONS R4 - >   R3:
#macro pLprojection( f )    // cree un tableau de points dans R3
    #local n1 = taille( f );    
    #local ff = array[n1]                     
    #local i=0; #while (i< n1)                
        #local p = f[i];
        #local temp = < p.x/p.t, p.y/p.t, p.z/p.t  >  ;
        #local ff[i] = temp;                 
    #local i=i+1; #end
    ff                                    
#end
#macro pSprojection( f )    // cree un tableau bidim dans R3
    #local n1 = taille( f );                
    #local n2 = taille( f[0] );                 
    #local ff = array[n1]                     
    #local pp = array[n2]                     
    #local i=0; #while (i< n1)                 
        #local j=0; #while (j< n2)             
            #local p = f[i][j];
            #local temp = < p.x/p.t, p.y/p.t, p.z/p.t  >  ;
            #local pp[j] = temp;         
        #local j=j+1; #end                        
        #local ff[i] = pp
    #local i=i+1; #end
    ff                                    
#end
#macro pLgetFrenet( curv, uu )
    #local ff = pFstretch( 1, curv, uu, uu+1 )
#local p0 = < ff[0].x/ff[0].t,ff[0].y/ff[0].t,ff[0].z/ff[0].t  >  ;
#local p1 = < ff[1].x/ff[1].t,ff[1].y/ff[1].t,ff[1].z/ff[1].t  >  ;
#local p2 = < ff[2].x/ff[2].t,ff[2].y/ff[2].t,ff[2].z/ff[2].t  >  ;
    #local tt = p1-p0;
    #local bb = vcross( tt, (p2-p0) );
    #local tt = vnormalize( tt );
    #local bb = vnormalize( bb );
    #local nn = vcross( bb, tt );
    array[4][4] {     { nn.x, bb.x, tt.x, p0.x },
            { nn.y, bb.y, tt.y, p0.y },
            { nn.z, bb.z, tt.z, p0.z },
            { 0,0,0,1 } }
#end
#macro pSgetPijk( surf, p )
    #local ff = pFstretch( 2, surf, 
            < p.x,p.y,p.z,p.t >  , < p.x+1,p.y+1,p.z,p.t >   )
    #local p0 = < ff[0][0].x/ff[0][0].t, ff[0][0].y/ff[0][0].t,
                     ff[0][0].z/ff[0][0].t  >  ;
    #local px = < ff[0][1].x/ff[0][1].t, ff[0][1].y/ff[0][1].t,
                     ff[0][1].z/ff[0][1].t  >  ;
    #local py = < ff[1][0].x/ff[1][0].t, ff[1][0].y/ff[1][0].t,
                     ff[1][0].z/ff[1][0].t  >  ;
    #local tx = px-p0;    #local tx = vnormalize( tx );
    #local ty = py-p0;    #local ty = vnormalize( ty );
    #local nn = vcross( tx, ty );
    array[4][4] {     { nn.x, tx.x, ty.x, p0.x },
                    { nn.y, tx.y, ty.y, p0.y },
                    { nn.z, tx.z, ty.z, p0.z },
                    { 0,0,0,1 } }
#end
#macro pSgetNormale( surf, p )
    #local ff = pFstretch( 2, surf, 
            < p.x,p.y,p.z,p.t >  , < p.x+1,p.y+1,p.z,p.t >   )
    #local p0 = < ff[0][0].x/ff[0][0].t, ff[0][0].y/ff[0][0].t,
                     ff[0][0].z/ff[0][0].t  >  ;
    #local px = < ff[0][1].x/ff[0][1].t, ff[0][1].y/ff[0][1].t,
                     ff[0][1].z/ff[0][1].t  >  ;
    #local py = < ff[1][0].x/ff[1][0].t, ff[1][0].y/ff[1][0].t,
                     ff[1][0].z/ff[1][0].t  >  ;
    #local nn = vcross( px-p0, py-p0 );
    #local nn = vnormalize( nn );
    nn
#end
#macro _pScalculer_normales( surf, M, N )    
    // methode exacte mais longue
    #local nn = array[M][N]// surf est la surface NON subdivise
    #local i=0; #while (i< M)// M et N : dims surface subdivise
        #local j=0; #while (j< N)
    #local nn[i][j] = pSgetNormale(surf,< i/(M-1),j/(N-1),0,1 >   );
        #local j=j+1; #end
    #local i=i+1; #end
    nn
#end
#macro pScalculer_normales( aa )        
    // methode rapide mais approche
    #local umax = taille(aa); // tableau des normales unitaires
    #local vmax = taille(aa[0]);        //
    #local nn = array[umax][vmax]
    // calcul des nn sauf aux bords maxis
    #local i = 0; #while (i< umax-1)
        #local j = 0; #while (j< vmax-1)
            #local p0 = aa[i][j];
            #local p1 = aa[i+1][j];
            #local p2 = aa[i][j+1];
            #local nn[i][j] = vnormalize( vcross( (p1-p0), (p2-p0) ) );
        #local j=j+1; #end
    #local i=i+1; #end
    // calcul aux bords
    #local i = 0; #while (i< umax-1)
        #local nn[i][vmax-1] = nn[i][vmax-2]*vdot(nn[i][vmax-3],nn[i][vmax-2])*2-nn[i][vmax-3];
    #local i=i+1; #end
    #local i = 0; #while (i< vmax-1)
        #local nn[umax-1][i] = nn[umax-2][i]*vdot(nn[umax-2][i],nn[umax-3][i])*2-nn[umax-3][i];
    #local i=i+1; #end
    #local nn[umax-1][vmax-1] = nn[umax-2][vmax-2]*vdot(nn[umax-2][vmax-2], nn[umax-3][vmax-3])*2 - nn[umax-3][vmax-3];
    // moyenne des normales sur deux triangles adjacents sur la diagonale
    #local i = 1; #while (i< umax-1)
        #local j = 1; #while (j< vmax-1)
            #local nn[i][j] = (nn[i-1][j-1] + 2*nn[i][j] + nn[i+1][j+1])/4;
        #local j=j+1; #end
    #local i=i+1; #end
    nn
#end
//    MACROS DE DESSIN DE COURBES, DE SURFACES ET DE VOLUMES:
#macro _pLdraw( f, rayon ) // dessine une suite de cylindres
    #local ff = pLprojection( f )
    #local n = taille( f );
    #local i = 0; #while (i< n-1)
        cylinder { ff[i], ff[i+1], rayon }
    #local i=i+1; #end
#end
#macro _pSdraw( ff, nn, qualite )                
    // dessine un pFmaillage de triangles
    #local umax = taille(ff);
    #local vmax = taille(ff[0]);
    mesh
    {    #local i = 0; #while (i< umax-1)
        #local j = 0; #while (j< vmax-1)
            #local p00 = ff[i][j];
            #local p10 = ff[i+1][j];
            #local p01 = ff[i][j+1];
            #local p11 = ff[i+1][j+1];
            #if (qualite)
                #local n00 = nn[i][j];
                #local n10 = nn[i+1][j];
                #local n01 = nn[i][j+1];
                #local n11 = nn[i+1][j+1];
            #end
            #if (qualite)
        smooth_triangle { p00, n00, p10, n10, p11, n11 }
        smooth_triangle { p00, n00, p11, n11, p01, n01 }
            #else
                triangle { p00, p10, p11 }
                triangle { p00, p11, p01 }
            #end
        #local j=j+1; #end
        #local i=i+1; #end
    }
#end
#macro _pVfaces( vvv )           // retourne les 6 surfaces limites d'un volume
    #local nx = taille( vvv );
    #local ny = taille( vvv[0] );
    #local nz = taille( vvv[0][0] );
    
    #local surf = array[6]
    
    #local ss = array[nx]
    #local i=0;    #while (i< nx)
        #local pp = array[ny]
        #local j=0;    #while (j< ny)
            #local pp[j] = vvv[nx-1-i][ny-1-j][nz-1]; 
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[0] = ss
    
    #local ss = array[nx]
    #local i=0;    #while (i< nx)
        #local pp = array[nz]
        #local j=0;    #while (j< nz)
            #local pp[j] = vvv[nx-1-i][ny-1][j];
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[1] = ss
    
    #local ss = array[ny]
    #local i=0;    #while (i< ny)
        #local pp = array[nz]
        #local j=0;    #while (j< nz)
            #local pp[j] = vvv[nx-1][i][j];
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[2] = ss
    
    #local ss = array[nx]
    #local i=0;    #while (i< nx)
        #local pp = array[ny]
        #local j=0;    #while (j< ny)
            #local pp[j] = vvv[nx-1-i][j][0];
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[3] = ss
    
    #local ss = array[nx]
    #local i=0;    #while (i< nx)
        #local pp = array[nz]
        #local j=0;    #while (j< nz)
            #local pp[j] = vvv[nx-1-i][0][nz-1-j];
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[4] = ss
    
    #local ss = array[ny]
    #local i=0;    #while (i< ny)
        #local pp = array[nz]
        #local j=0;    #while (j< nz)
            #local pp[j] = vvv[0][i][nz-1-j];
        #local j=j+1; #end
        #local ss[i] = pp
    #local i=i+1; #end
    #local surf[5] = ss
    surf
#end
#macro pVdrawPijk( vol, p, longueur, rayon )   // A REVOIR, REPERE NON ORTHONORME
    // dessine le repre tangent en p au volume  
    #local p0 = pFgetPoint( 3, vol, <p.x, p.y, p.z, p.t> )
    #local pu = pFgetPoint( 3, vol, <p.x+1, p.y, p.z, p.t> )
    #local pv = pFgetPoint( 3, vol, <p.x, p.y+1, p.z, p.t> )
    #local pw = pFgetPoint( 3, vol, <p.x, p.y, p.z+1, p.t> )
    #local q0 = <p0.x/p0.t, p0.y/p0.t, p0.z/p0.t> ;
   	#local qu = <pu.x/pu.t, pu.y/pu.t, pu.z/pu.t> ;
   	#local qv = <pv.x/pv.t, pv.y/pv.t, pv.z/pv.t> ;
   	#local qw = <pw.x/pw.t, pw.y/pw.t, pw.z/pw.t> ;
    #local ti = vnormalize( qu-q0 ) 
    #local tj = vnormalize( qv-q0 ) 
    #local tk = vnormalize( qw-q0 ) 
    union
	{ 	cylinder {q0,q0+ti*longueur, rayon une_couleur( < 1,0,0 >   ) }
  		cylinder {q0,q0+tj*longueur, rayon une_couleur( < 0,1,0 >   ) }
  		cylinder {q0,q0+tk*longueur, rayon une_couleur( < 0,0,1 >   ) }
	}
#end 
#macro pSdrawPijk( surf, p, longueur, rayon )        
    // dessine le repre tangent en p  la surface  
    #local mat = pSgetPijk( surf, p )
    #local nn = < mat[0][0], mat[1][0], mat[2][0]  >  ;
    #local tx = < mat[0][1], mat[1][1], mat[2][1]  >  ;
    #local ty = < mat[0][2], mat[1][2], mat[2][2]  >  ;
    #local p0 = < mat[0][3], mat[1][3], mat[2][3]  >  ;
    union
	{ 	cylinder {p0,p0-nn*longueur, rayon une_couleur( < 1,0,0 >   ) }
  		cylinder {p0,p0+tx*longueur, rayon une_couleur( < 0,1,0 >   ) }
  		cylinder {p0,p0+ty*longueur, rayon une_couleur( < 0,0,1 >   ) }
	}
#end 
#macro pSdrawNormale( surf, p, longueur, rayon )        
    // dessine la normale en p  la surface
    #local ff = pFstretch( 2, surf, < p.x,p.y,p.z,p.t >, < p.x+1,p.y+1,p.z,p.t >   )
    #local p0 = < ff[0][0].x/ff[0][0].t, ff[0][0].y/ff[0][0].t, ff[0][0].z/ff[0][0].t  >  ;
    #local px = < ff[0][1].x/ff[0][1].t, ff[0][1].y/ff[0][1].t, ff[0][1].z/ff[0][1].t  >  ;
    #local py = < ff[1][0].x/ff[1][0].t, ff[1][0].y/ff[1][0].t, ff[1][0].z/ff[1][0].t  >  ;
    #local nn = vcross( px-p0, py-p0 );
    #local nn = vnormalize( nn );
    cylinder { p0, p0-nn*longueur, rayon }
#end
#macro pLdrawFrenet( curv, uu, longueur, rayon )        
    // dessine le repre de frenet en uu  la courbe
    #local mat = pLgetFrenet( curv, uu )
    #local nn = < mat[0][0], mat[1][0], mat[2][0]  >  ;
    #local bb = < mat[0][1], mat[1][1], mat[2][1]  >  ;
    #local tt = < mat[0][2], mat[1][2], mat[2][2]  >  ;
    #local p0 = < mat[0][3], mat[1][3], mat[2][3]  >  ;
    union
    { cylinder{ p0,p0+nn*longueur, rayon une_couleur(< 0,1,0 >  ) }
      cylinder{ p0,p0+bb*longueur, rayon une_couleur(< 0,0,1 >  ) }
      cylinder{ p0,p0+tt*longueur, rayon une_couleur(< 1,0,0 >  ) }
    }
#end
//    INTERFACE POUR LE DESSIN DES FORMES:
//    1)    GESTION DES PARAMETRES D'AFFICHAGE
#declare STANDARD       = -1;
#declare POINT          = 0;
#declare COURBE         = 1;
#declare SURFACE        = 2;
#declare ENVELOPPE      = 3;
#declare HYPER          = 4;
#declare FEUILLES       = 5;
#declare FIBRES         = 6;
#declare NORMALES       = 7;
#declare REPERE         = 8;
#declare COULEUR        = 0;
#declare TEXTURE        = 1;
#declare FACETTES       = -1;
#declare LISSE          = 0;
#declare SUPER          = 1;
#declare FORME          = POINT;
#declare ASPECT         = COULEUR;
#declare QUALITE        = FACETTES;
#declare RAYON          = 0.05;
#declare LONGUEUR       = 0.1;
#declare CHOIX_COULEUR  = < 1,0,0 >  ;
#declare CHOIX_TEXTURE  = 1;
#macro standards()
    #declare FORME          = POINT;
    #declare ASPECT         = COULEUR;
    #declare QUALITE        = FACETTES;
    #declare RAYON          = 0.05;
    #declare LONGUEUR       = 0.1;
    #declare CHOIX_TEXTURE  = 1;
    #ifdef (CHOIX_COULEUR) #undef CHOIX_COULEUR #end    
    #declare CHOIX_COULEUR  = < 1,0,0 >  ;
    #ifdef (RECURSION) #undef RECURSION #end
#end
#macro finesse( r )
    #ifdef (RECURSION) #undef RECURSION #end     
    #declare RECURSION = r; 0 
#end
#macro le_point( r )     
    #declare FORME = POINT; #declare RAYON = r; 0 
#end
#macro courbe( r )         
    #declare FORME = COURBE; #declare RAYON = r; 0 
#end
#macro surface( q )     
    #declare FORME = SURFACE; #declare QUALITE = q; 0 
#end
#macro enveloppe( q )     
    #declare FORME = ENVELOPPE; #declare QUALITE = q; 0 
#end
#macro feuilles( q )     
    #declare FORME = FEUILLES; #declare QUALITE = q; 0 
#end
#macro fibres( r )        
    #declare FORME = FIBRES; #declare RAYON = r; 0 
#end
#macro normales( r, l ) 
    #declare FORME = NORMALES; #declare RAYON = r; 
    #declare LONGUEUR = l; 0 
#end
#macro repere( r, l )     
    #declare FORME = REPERE; #declare RAYON = r; 
    #declare LONGUEUR = l; 0 
#end
#macro ma_couleur( c )     
    #declare ASPECT = COULEUR; 
    #ifdef (CHOIX_COULEUR) #undef CHOIX_COULEUR #end 
    #declare CHOIX_COULEUR = c; 0 
#end
#macro ma_texture( c )     
    #declare ASPECT = TEXTURE; #declare CHOIX_TEXTURE = c; 0
#end
////////////////////////////////////////////////////////////////////////
//    2)    APPEL DES MACROS
#macro __pSdraw( f, ff, etat )
    #switch (etat)
    #case (FACETTES)
        #local nn = ff    // pour leurer la macro _draw_surface
        _pSdraw( ff, nn, false)
    #break
    #case (LISSE)
        #local nn = pScalculer_normales( ff )
        _pSdraw( ff, nn, ((QUALITE >=LISSE) ? true : false))
    #break
    #case (SUPER)    
        #local nn = 
    _pScalculer_normales( f, taille(ff), taille(ff[0]) )
        _pSdraw( ff, nn, ((QUALITE >=LISSE) ? true : false))
    #break
    #end
#end
#macro pPdraw( f )
    pFdraw( 0, f, RAYON )
#end
#macro pLdraw( f )
    #ifndef (RECURSION) #declare RECURSION = 0; #end
    #local pf = pFsubdivision( 1, f, < RECURSION,0,0,0 >   )
    #local ppf = pLprojection( pf )
    #switch (FORME)     
    #case (POINT)    
        union { pFdraw( 1, pf, RAYON )     }
    #break
    #case (COURBE)    
        union { _pLdraw( pf, RAYON ) }        
    #break
    #case (REPERE)
        #local n = taille( pf );
        union
        {    #local i = 0; #while (i< n)
            pLdrawFrenet( f, i/(n-1), LONGUEUR, RAYON )
            #local i=i+1; #end
        }
    #break
    #end
#end
#macro pSdraw( f )
    #ifndef (RECURSION) #declare RECURSION = < 0,0 >  ; #end
    #local pf = 
    pFsubdivision( 2, f, < RECURSION.x,RECURSION.y,0,0 >   )
    #local ppf = pSprojection( pf )
    #switch (FORME)     
    #case (POINT)    
        union { pFdraw( 2, pf, RAYON ) }    
    #break
    #case (COURBE)
        union
        {   #local i=0; #while(i< taille(pf))    
                _pLdraw( pf[i], RAYON ) 
            #local i=i+1; #end
        }   
    #break
    #case (SURFACE)
        __pSdraw( f, ppf, QUALITE )    
    #break
    #case (NORMALES)        
    // il faut calculer le juste point base de la normale...
        #local m = taille(ppf);
        #local n = taille(ppf[0]);
        #local nn = _pScalculer_normales( f, m, n  )    
        union
        {    #local i=0; #while(i< m)
            #local j=0; #while(j< n)
    cylinder { ppf[i][j], ppf[i][j] + nn[i][j]*LONGUEUR, RAYON }
            #local j=j+1; #end
            #local i=i+1; #end
        }
    #break
    #end
#end
#macro pVdraw( f )
    #ifndef (RECURSION) #declare RECURSION = < 0,0,0 >  ; #end
    #switch (FORME) 
    #case (POINT)    
        #local pf = pFsubdivision( 3, f, < RECURSION.x,RECURSION.y,RECURSION.z,0 >   )
        union { pFdraw( 3, pf, RAYON ) }        
    #break
    #case (ENVELOPPE)
        #local surf = _pVfaces( f )    
        union
        {   #local i=0; #while (i< 6)
            #local psurfi = pFsubdivision( 2, surf[i], < RECURSION.x,RECURSION.y,RECURSION.z,0 > )
            #local ffi = pSprojection( psurfi )
            __pSdraw( surf[i], ffi, QUALITE )
            #local i=i+1;    #end
        }
    #break
    #case (FEUILLES)
         #local pf = pFsubdivision(3,f,RECURSION )
        union 
        {   #local n = taille(pf);
            #local i=0; #while (i< n)
            #local psurfi = pf[i]
            #local ffi = pSprojection( psurfi )
            __pSdraw( pf[i], ffi, QUALITE )
            #local i=i+1; #end
        }
    #break
    #case (FIBRES)
        #local pf = pFsubdivision( 3, f, < RECURSION.x,RECURSION.y,RECURSION.z,0 >  )
        union 
        {   #local nb = taille(pf);
            #local m = taille(pf[0]);
            #local n = taille(pf[0][0]);
            #local i=0; #while (i< m)
            #local j=0; #while (j< n)
                #local poil = array[nb]
                #local k=0; #while (k< nb)
                    #local poil[k] = pf[k][i][j];
                #local k=k+1; #end
                _pLdraw( poil, RAYON )
            #local j=j+1; #end
            #local i=i+1; #end
        }
    #break
    #end
#end
#macro pHdraw( f )
    #ifndef (RECURSION) #declare RECURSION = < 0,0,0,0 >  ; #end
    #local pf = pFsubdivision( 4, f, RECURSION )
    union { pFdraw( 4, pf, RAYON ) }
#end
//    2)    MACRO FONDAMENTALE
#macro draw( dim, f, options )
    object
    {    #switch (dim)
            #case (0)    pPdraw( f )    #break
            #case (1)    pLdraw( f )    #break
            #case (2)    pSdraw( f )    #break
            #case (3)    pVdraw( f )    #break
            #case (4)    pHdraw( f )    #break
            #else    #debug "...nothing out there! Yet..."
        #end
        #if (ASPECT = COULEUR)
            une_couleur( CHOIX_COULEUR ) #end
        #if (ASPECT = TEXTURE)
            une_texture( CHOIX_TEXTURE ) #end
    }
    standards() // rinitialise les valeurs des paramtres
#end
/*----------- MACROS UTILES ------------*/
#macro axes( Ox, Oy, Oz )
    #if (Ox) cylinder { < -10,0,0 >  ,< 10,0,0 >  , 0.005 
            pigment{ color rgb  < 1,0,0 >   } }     #end
    #if (Oy) cylinder { < 0,-10,0 >  , < 0,10,0 >  , 0.005 
            pigment { color rgb  < 0,1,0 >   } }    #end
    #if (Oz) cylinder { < 0,0,-10 >  , < 0,0,10 >  , 0.005 
            pigment { color rgb  < 0,0,1 >   } }    #end
#end
#declare OX  = 1; 
#declare OY  = 2; 
#declare OZ  = 3; 
#declare AXO = 4;
#macro vue_axonometrique( axe, zoom )
    camera 
    {    orthographic
        #switch (axe)
            #case (OX)    location < 10,0,0 >       #break
            #case (OY)    location < 0,10,0 >       #break
            #case (OZ)    location < 0,0,-10 >       #break
            #case (AXO)    location < 10,10,-10 >       #break
        #end
        right < 1,0,0 >   
        look_at < 0,0,0 >   scale 1/zoom
    }
    #switch (axe)
        #case (OX)    axes( false, true, true ) #break
        #case (OY)    axes( true, false, true ) #break
        #case (OZ)    axes( true, true, false ) #break
        #case (AXO)    axes( true, true, true )  #break
    #end
#end
#macro vue_perspective( observateur )
    camera {    location observateur 
                right < 1,0,0 >   
                look_at < 0,0,0 >   }
    axes( true, true, true )
#end
#macro sol( hauteur )
    plane 
    {     < 0,1,0 >  , hauteur
        texture     
        {    pigment {  color rgb 0.5 }    
        // checker color rgb 0.3 color rgb 0.7 scale 1/4
            finish {     ambient 0.2 
                    diffuse 0.5 
                    specular 0.7 
                    roughness 0.01 
                    reflection 0.8
                }
        }
    }
#end
#macro ciel()
    sky_sphere 
    {     pigment 
        {     marble    // gradient y 
            color_map { 
                    [0.0 color rgb 1/4] 
                    [1.0 color rgb 3/4] 
                }
            //scale 1/2
            turbulence 0.5
            rotate < 0,0,90 >  
        }
    }
#end
//    THE END, the show can start now...
